char ERRORMESSAGE_[(80+1)];

#include <stdlib.h>

#include <stdio.h>

#include <math.h>

#include <limits.h>

#include <string.h>


#include <setjmp.h>

#include <errno.h>

#include <signal.h>
#define ofs(struct,field) (&(struct *)NULL->field-(struct *)NULL)
struct arrptr{int l,h,i; char *a;};
struct dynptr{int t; void* p;};


jmp_buf errorhook;
int dynptrerr(int inputpos){
  sprintf(ERRORMESSAGE_, "Incompatible argument in line %d",inputpos);
  longjmp(errorhook,1);
}
void inputerr(FILE *fil){
  char where[11];
  long cn, fn;
  fn=fileno(fil);
  cn=ftell(fil);
  fscanf(fil,"%10s",where);
  sprintf(ERRORMESSAGE_,"Unrecognized input \"%s\" from fd %d char %d",where,fn,cn);
  longjmp(errorhook,1);
}
void *errmalloc(){
  sprintf(ERRORMESSAGE_,"Not enough memory");
  longjmp(errorhook,1);
  }
void errfclose(FILE **f){
  long fn;
  fn=fileno(*f);
  if(fn>=0 && fclose(*f)!=0){
    sprintf(ERRORMESSAGE_,"Error in closing fd %d: %s",fn,strerror(errno));
    longjmp(errorhook,1);
    }
  *f=NULL;
  }
void errfopen(FILE **f, const char *name, const char *mode){
  if(*f)errfclose(f);
  *f=fopen(name,mode);
  if(*f==NULL){
    sprintf(ERRORMESSAGE_,"Error in opening %s: %s",name,strerror(errno));
    longjmp(errorhook,1);
    }
  }
int scanrec(FILE *f, const char *format, void *var) {
  long pos; int res;
  pos=ftell(f);
  res=fscanf(f,format,var);
  if (res<=0) fseek(f,pos,SEEK_SET);
  return res;
}
int myfgets(char *name, char *var, char *varend, FILE *f) {
  long pos;
  register int c;
  pos=ftell(f);
  while(*name!=0){
    if(*name==' '){while((c=getc(f))<=' '){};ungetc(c,f);} else
    if(*name!=getc(f)){fseek(f,pos,SEEK_SET);return 0;};
    name++;
  };
  do{c=getc(f); *var=c;}while(c!=EOF && c!='\n' && ++var < varend);
  *var=0;
  return 1;
}
#if defined __linux__
#include <fpu_control.h>
const fpu_control_t fpu=_FPU_DEFAULT & ~(_FPU_MASK_IM | _FPU_MASK_ZM | _FPU_MASK_OM);
#endif
void trapsignal(int signum){
  if(signum==SIGINT) ERRORMESSAGE_[0]=0; else
  strncpy(ERRORMESSAGE_,sys_siglist[signum],sizeof(ERRORMESSAGE_));
#if defined __linux__
  _FPU_SETCW(fpu);
#endif
  longjmp(errorhook,1);
}


#include <fcntl.h>

#include <unistd.h>

#include <sys/types.h>

#include <sys/stat.h>


#include <dlfcn.h>

#include <termios.h>

struct termios oldsetting;
void restore_termios(){tcsetattr(STDIN_FILENO,TCSANOW,&oldsetting);}
void single_char_input(void){
  struct termios setting;
  tcgetattr(STDIN_FILENO,&setting);
  oldsetting=setting;
  setting.c_lflag &= ~ICANON;
  setting.c_cc[VMIN]=0;
  setting.c_cc[VTIME]=0;
  tcsetattr(STDIN_FILENO,TCSANOW,&setting);
}  

#ifdef __i386__
#define mmovefrom(var,buf,type) *(type *)(buf)=*var
#define mmoveto(var,buf,type) *var=*(type *)(buf)
#else
#define mmovefrom(var,buf,type) memmove(buf,var,sizeof(type))
#define mmoveto(var,buf,type) memmove(var,buf,sizeof(type))
#endif

struct item_{struct item_ *brother_;struct item_ *son_;int length_;char scope_;char body_[1];};
struct item_ NIL_;  void fri_3NewItem(struct item_ **head_,char *buf_,int newlength_,char newscope_){struct item_ *oldhead_;
  
  oldhead_=(*head_);
  (*head_)=malloc(newlength_+sizeof(struct item_)-1);
  (*(*head_)).brother_=oldhead_;
  (*(*head_)).son_=&NIL_;
  (*(*head_)).scope_=newscope_;
  (*(*head_)).length_=newlength_;
  if( newlength_>0 ){ {  memmove(((*(*head_)).body_),(buf_),(newlength_));
};};
}

void fri_4DisposeItem(struct item_ **head_){
  while( (*(*head_)).son_!=&NIL_){  fri_4DisposeItem(&(*(*head_)).son_) ;}
  {struct item_ * temp=(*(*head_)).brother_;free((*head_));(*head_)=temp;};
}

void fri_5SplitItem(struct item_ **it_,int pos_){struct item_ *it2_;
  
  it2_=malloc((*(*it_)).length_-pos_+sizeof(struct item_)-1);
  (*it2_).length_=(*(*it_)).length_-pos_;
  (*it2_).brother_=&NIL_;
  (*it2_).son_=(*(*it_)).son_;
  (*(*it_)).son_=it2_;
  (*it2_).scope_=(*(*it_)).scope_;
  {  memmove(((*it2_).body_),(pos_+(*(*it_)).body_),((*(*it_)).length_-pos_));
};
  (*(*it_)).length_=pos_;
/*!   it=realloc(it^,pos+SIZEOF(item)-1)*/
/*!   bisogna evitare movimenti del pointer*/
}

char root_[sizeof(struct item_*)*((unsigned char)'\342'-((unsigned char)'\200')+1)];
char rootscope_[((unsigned char)'\342'-((unsigned char)'\200')+1)];
char topstrand_;
char curscope_;
int TraceOn_;
int seqn_;

char inputfile_[sizeof(int)*10];
char inputstart_[sizeof(int)*10];
char inputline_[sizeof(int)*10];
char outputfile_[sizeof(int)*10];
char buffer_[300000];
char ibuf_[(BUFSIZ+256)];
char bufmark_[sizeof(char*)*500];
char *bufstart_;
char ifname_[sizeof(char*)*10];
int curfile_;
int outfile_;
int inpstack_;
int inputend_;
int counter_;

struct inps_{int pos_;int iend_;int ln_;char ch_;};

struct fri_s6{char *output_;char *parstack_;struct inps_ input_;};
struct fri_s6 ioptrs_;  

void fri_7SystemError(char *s_);

void fri_8AddBuf(char *from_){
  if( ioptrs_.input_.pos_<inpstack_ ){
int _l9;
int _oldinpstack10;
    _l9=((signed)(ioptrs_.output_-from_));

    ioptrs_.input_.pos_-=_l9;
    _oldinpstack10=inpstack_;

    inpstack_=ioptrs_.input_.pos_-sizeof(int);
    {int temp=_oldinpstack10;mmovefrom(&temp, (300000+inpstack_)+buffer_  ,int );}
    if( _l9==0 ){ return;};
    ioptrs_.input_.ch_=(*(from_));
    {  memmove(((300000+ioptrs_.input_.pos_)+buffer_),(from_),(_l9));
};
  }else{
int _oldinpstack11;
    (*(ioptrs_.output_))=('\177');
    _oldinpstack11=inpstack_;

    inpstack_-=(sizeof(struct inps_));;
    mmovefrom(&ioptrs_.input_, (300000+inpstack_)+buffer_  ,struct inps_ );
    ioptrs_.input_.iend_=inpstack_;
    inpstack_-=(((signed)(ioptrs_.output_-from_))+1);;
    {  memmove(((300000+inpstack_)+buffer_),(from_),(((signed)(ioptrs_.output_-from_))+1));
};
    ioptrs_.input_.pos_=inpstack_;
    ioptrs_.input_.ch_=(*((300000+ioptrs_.input_.pos_)+buffer_));
    inpstack_-=(sizeof(int));;
    {int temp=_oldinpstack11;mmovefrom(&temp, (300000+inpstack_)+buffer_  ,int );}
    if( ioptrs_.output_>=(300000-256+inpstack_)+buffer_){ fri_7SystemError("buffer full");};
  };
}


void fri_10moveback(){int ipos_;
  
  ipos_=ioptrs_.input_.pos_-(*(int *)(curfile_*sizeof(int)+inputstart_-sizeof(int)))-256;if( ipos_<0 ){ ipos_=0;};
  lseek((*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int))),ipos_,SEEK_SET);
  inputend_=(*(int *)(curfile_*sizeof(int)+inputstart_-sizeof(int)))+ipos_+read((*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int))),ibuf_,BUFSIZ);
  bufstart_=(-(*(int*)(curfile_*sizeof(int)+inputstart_-sizeof(int)))-ipos_)+ibuf_;
}

void fri_11Refresh(){
  {  memmove((ibuf_),((inputend_-256)+bufstart_),(256));
};
  bufstart_=(256-inputend_)+ibuf_;
  _includefile:{
if( (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))==STDIN_FILENO ){
      (*(ioptrs_.output_))='\000';

      {char *readline();
       char* il=readline(*(char**)ioptrs_.parstack_);
       if(il && *il)add_history(il);
       strcpy(ibuf_+256,il); inputend_+=strlen(il);
       free(il);}

       (*(inputend_+bufstart_))=('\012');  inputend_+=1;;
    }else{
inputend_+=read((*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int))),256+ibuf_,BUFSIZ);;
};
if( inputend_>ioptrs_.input_.pos_ ){ return;};
    ioptrs_.input_.pos_-=1;;  (*(ioptrs_.input_.pos_+bufstart_))=('\177');
    if( curfile_==1 ){ return;};
    close((*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int))));
    curfile_-=1;;
    ioptrs_.input_.ln_=(*(int *)(curfile_*sizeof(int)+inputline_-sizeof(int)));
if( (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))==STDIN_FILENO ){
      (*(inputend_+bufstart_))=('\012');  inputend_+=1;;
      return;
    };  
lseek((*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int))),(*(int *)(curfile_*sizeof(int)+inputstart_-sizeof(int))),SEEK_SET);
    (*(int *)(curfile_*sizeof(int)+inputstart_-sizeof(int)))=inputend_-(*(int *)(curfile_*sizeof(int)+inputstart_-sizeof(int)));
   goto _includefile;} includefile:;
}


void fri_13GetChar(){
  {
  ioptrs_.input_.pos_+=1;;
  if( ioptrs_.input_.pos_<0 ){
    if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_ ){  
      mmoveto(&ioptrs_.input_,(300000+ioptrs_.input_.iend_)+buffer_,struct inps_ );
    }else{ ioptrs_.input_.ch_=(*((ioptrs_.input_.pos_+300000)+buffer_));};
  }else{
    if( ioptrs_.input_.ch_=='\012' ){ ioptrs_.input_.ln_+=1;;};
    if( ioptrs_.input_.pos_>=inputend_ ){ fri_11Refresh();};
    if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
    ioptrs_.input_.ch_=(char)(((unsigned char)(*(ioptrs_.input_.pos_+bufstart_) )& 127));
    if( ioptrs_.input_.ch_=='\015' ){ /*! skip cr*/
      if( (*(ioptrs_.input_.pos_+bufstart_))=='\215' ){ fri_13GetChar();};
      fri_13GetChar();
    };
  };
};
}


   

int fri_16Include(){int RESULT_;
  if( (curfile_>=10 )||( ioptrs_.input_.pos_<0 )){ fri_7SystemError("too many open files");};
  (*(ioptrs_.output_))='\000';  ioptrs_.output_=1+ioptrs_.output_;;
  curfile_+=1;;
  if( (*((*(char**)ioptrs_.parstack_)))=='-' ){ (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))=STDIN_FILENO ;}else{  (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))= open((*(char **)(ioptrs_.parstack_)),O_RDONLY);};
  if( (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))<0 ){ curfile_-=1;; RESULT_=0; return RESULT_;};
  (*(char **)(curfile_*sizeof(char*)+ifname_-sizeof(char*)))=(*(char **)(ioptrs_.parstack_));
  seqn_=0;
  if( curfile_>1 ){
    if( (*(int *)((curfile_-1)*sizeof(int)+inputfile_-sizeof(int)))!=STDIN_FILENO ){ (*(int *)((curfile_-1)*sizeof(int)+inputstart_-sizeof(int)))=lseek((*(int *)((curfile_-1)*sizeof(int)+inputfile_-sizeof(int))),0,SEEK_CUR)+ioptrs_.input_.pos_-inputend_;};
    (*(int *)((curfile_-1)*sizeof(int)+inputline_-sizeof(int)))=ioptrs_.input_.ln_;
  };
  ioptrs_.input_.ln_=1;
  inputend_=ioptrs_.input_.pos_;
  (*(int *)(curfile_*sizeof(int)+inputstart_-sizeof(int)))=inputend_;
  if( (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))!=STDIN_FILENO ){ ioptrs_.input_.pos_-=1;; ioptrs_.input_.ch_='\000'; fri_13GetChar();};
  RESULT_=1;
return RESULT_;}






char zero_;
char duecento55_;
void fri_22WrTree(struct item_ *head_){
  _l23:{
   if( head_==&NIL_ ){ write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(char *)&zero_,1); return;};
    if( (*head_).length_>=254 ){
int _h24;
      _h24=(*head_).length_-1;
 fprintf(stdout,"""Line must be split: " "%0.*s",_h24-(0)+1,(*head_).body_ +0);putc('\n',stdout);
/*! la scrittura binaria di "length" non e` portabile ad altre architetture*/
      write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(char *)&duecento55_,1);
      write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(char *)&(*head_).length_,sizeof(int));
    }else{
char l_;
            l_=(char)((*head_).length_+1);write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(char *)&l_,1);
    };
    write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(*head_).body_,(*head_).length_);
    fri_22WrTree((*head_).son_);
/*!    WrTree(head.brother)*/
    head_=(*head_).brother_;
   goto _l23;} _l23_exit:;
}


void fri_24RdTree(struct item_ **head_){
_l25:{char l_;  int il_;
  
  {
  if( ioptrs_.input_.pos_+(1)>=inputend_ ){ fri_11Refresh();};
  if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
  {  memmove((((char *)&l_)),(ioptrs_.input_.pos_+bufstart_),((1)));
};
  ioptrs_.input_.pos_+=(1);
};
  if( l_=='\000' ){ (*head_)=&NIL_; return;};
  if( l_=='\377' ){
    {
  if( ioptrs_.input_.pos_+(sizeof(int))>=inputend_ ){ fri_11Refresh();};
  if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
  {  memmove((((char *)&il_)),(ioptrs_.input_.pos_+bufstart_),((sizeof(int))));
};
  ioptrs_.input_.pos_+=(sizeof(int));
};
  }else{ il_=(unsigned char)l_-1;};
  (*head_)=malloc(il_+sizeof(struct item_)-1);
  (*(*head_)).length_=il_;
  (*(*head_)).scope_=curscope_;
  {
  if( ioptrs_.input_.pos_+((*(*head_)).length_)>=inputend_ ){ fri_11Refresh();};
  if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
  {  memmove((((char *)(*(*head_)).body_)),(ioptrs_.input_.pos_+bufstart_),(((*(*head_)).length_)));
};
  ioptrs_.input_.pos_+=((*(*head_)).length_);
};
  fri_24RdTree(&(*(*head_)).son_);
/*!  RdTree(head.brother)*/
  head_=&(*(*head_)).brother_;
 goto _l25;} _l25_exit:;
}


void fri_26Increment(){
  ioptrs_.output_= -1+ioptrs_.output_;;
  if( ((ioptrs_.output_>=(*(char **)(ioptrs_.parstack_) ))&&( (unsigned char)(*(ioptrs_.output_))>=(unsigned char)'0'))&&( (unsigned char)(*(ioptrs_.output_))<=(unsigned char)'9')){
    if( (*(ioptrs_.output_))=='9' ){
      fri_26Increment();
      (*(ioptrs_.output_))='0';
    }else{
      (*(ioptrs_.output_))=(char)((unsigned char)(*(ioptrs_.output_))+1);
    };
  }else{  
    ioptrs_.output_=1+ioptrs_.output_;;  (*(ioptrs_.output_))='1';
  };
  ioptrs_.output_=1+ioptrs_.output_;;
}

void *curlib_;
int fri_bcode_1Match(struct item_ *pattern_,char *CS_,char *CSend_);

char *fri_bcode_2bytexec(char *CS_){char *RESULT_;char *_FP3;
jmp_buf _eh4;
  int A_;

_FP3=(*(char **)(ioptrs_.parstack_));
memcpy(&_eh4,&errorhook,sizeof(jmp_buf)); if(setjmp(errorhook)){memcpy(&errorhook,&_eh4,sizeof(jmp_buf));if(strncmp(ERRORMESSAGE_,"",strlen("")))longjmp(errorhook,1);else{ fprintf(stderr ,"%0.*s",80-(0)+1,ERRORMESSAGE_+0);putc('\n',stderr );
  while( (*(CS_))!=('\376')){
    CS_=1+CS_;;
  }
  (*(char **)(ioptrs_.parstack_))=_FP3;
  RESULT_=CS_;
}}else{
_go:{
CS_=1+CS_;;
switch( (unsigned char)(*(CS_) )){
case (unsigned char)'\001':{int _5;
 mmoveto(&_5,(1+CS_),int );CS_=(_5)+CS_;
}break;
case (unsigned char)'\004':{ char *_saveoutput6;
struct item_ *_p7;
 _saveoutput6=ioptrs_.output_;

       CS_=1+CS_;;
       {do{(*(ioptrs_.output_))=(*(CS_));  ioptrs_.output_=1+ioptrs_.output_;;  CS_=1+CS_;;   }while(!((*(CS_))==('\004')));}
       fri_8AddBuf(_saveoutput6);
       ioptrs_.output_=_saveoutput6;
       _p7=(*(struct item_ **)(((unsigned char)ioptrs_.input_.ch_)*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));

       fri_13GetChar();
       if( fri_bcode_1Match(_p7,(*_p7).body_,((*_p7).length_)+(*_p7).body_) ){ }; 
}break;
case (unsigned char)'\376':{ goto go;
}break;
case (unsigned char)'\003':{typedef void (*_t11)(char *);
void (*sumcall_)(char *);
        mmoveto(&sumcall_,(1+CS_),_t11);(*sumcall_)((*(char **)(ioptrs_.parstack_)));
       CS_=sizeof(char*)+CS_;;
}break;
case (unsigned char)'\011':{ {  memmove((ioptrs_.output_),(1+CS_),(sizeof(double)));
};
          ioptrs_.output_=sizeof(double)+ioptrs_.output_;
	  CS_=sizeof(double)+CS_;
}break;
case (unsigned char)'\013':{int _len12;
 mmoveto(&_len12,(1+CS_),int );

       {  memmove((ioptrs_.output_),((1+sizeof(int))+CS_),(_len12));
};
       ioptrs_.output_=_len12+ioptrs_.output_;
       CS_=(sizeof(int)+_len12)+CS_;
}break;
case (unsigned char)'\015':{ ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
}break;
case (unsigned char)'\017':{ ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
}break;
case (unsigned char)'\007':{void *_13;
 ioptrs_.output_=(-sizeof(void*))+ioptrs_.output_;;
      mmoveto(&_13,ioptrs_.output_,void *);free(_13);
}break;
case (unsigned char)'\014':{int _14;
 mmoveto(&_14,1+CS_,int );{char *temp=(_14)+_FP3;mmovefrom(&temp, ioptrs_.output_,char *);}
       ioptrs_.output_=sizeof(char*)+ioptrs_.output_;;
       CS_=sizeof(int)+CS_;;
}break;
case (unsigned char)'\021':{char *_from15;
int _16;
 mmoveto(&_16,1+CS_,int );_from15=(_16)+_FP3;

       {  memmove((ioptrs_.output_),(_from15),(sizeof(double)));
};
       ioptrs_.output_=sizeof(double)+ioptrs_.output_;;
       CS_=sizeof(int)+CS_;;
}break;
case (unsigned char)'\022':{int _len17;
char *_from18;
int _19;
 mmoveto(&_len17,1+CS_,int );

       mmoveto(&_19,(1+sizeof(int))+CS_,int );_from18=(_19)+_FP3;

       {  memmove((ioptrs_.output_),(_from18),(_len17));
};
       ioptrs_.output_=_len17+ioptrs_.output_;;
       CS_=(2*sizeof(int))+CS_;;
}break;
case (unsigned char)'\024':{char *_from20;
 mmoveto(&_from20,1+CS_,char *);

       {  memmove((ioptrs_.output_),(_from20),(sizeof(double)));
};
       ioptrs_.output_=sizeof(double)+ioptrs_.output_;;
       CS_=sizeof(char*)+CS_;;
}break;
case (unsigned char)'\025':{int _len21;
char *_from22;
 mmoveto(&_len21,1+CS_,int );

       mmoveto(&_from22,(1+sizeof(int))+CS_,char *);

       {  memmove((ioptrs_.output_),(_from22),(_len21));
};
       ioptrs_.output_=_len21+ioptrs_.output_;;
       CS_=(sizeof(int)+sizeof(char*))+CS_;;
}break;
case (unsigned char)'\026':{int _len23;
char *_from24;
 mmoveto(&_len23,1+CS_,int );

       ioptrs_.output_=(-sizeof(char*))+ioptrs_.output_;;
       mmoveto(&_from24,ioptrs_.output_,char *);

       {  memmove((ioptrs_.output_),(_from24),(_len23));
};
       ioptrs_.output_=_len23+ioptrs_.output_;;
       CS_=sizeof(int)+CS_;;
}break;
case (unsigned char)'\027':{int _len25;
char *_from26;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;
       mmoveto(&_len25,ioptrs_.output_,int );

       ioptrs_.output_=(-sizeof(char*))+ioptrs_.output_;;
       mmoveto(&_from26,ioptrs_.output_,char *);

       {  memmove((ioptrs_.output_),(_from26),(_len25));
};
       ioptrs_.output_=_len25+ioptrs_.output_;;
}break;
case (unsigned char)'\031':{char *_to27;
int _28;
 mmoveto(&_28,1+CS_,int );_to27=(_28)+_FP3;

        ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;;
        {  memmove((_to27),(ioptrs_.output_),(sizeof(double)));
};
        CS_=sizeof(int)+CS_;;
}break;
case (unsigned char)'\032':{int _len29;
char *_to30;
int _31;
 mmoveto(&_len29,1+CS_,int );

       mmoveto(&_31,(1+sizeof(int))+CS_,int );_to30=(_31)+_FP3;

       ioptrs_.output_=(-_len29)+ioptrs_.output_;;
       {  memmove((_to30),(ioptrs_.output_),(_len29));
};
       CS_=(2*sizeof(int))+CS_;;
}break;
case (unsigned char)'\034':{char *_to32;
 mmoveto(&_to32,1+CS_,char *);

        ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;;
        {  memmove((_to32),(ioptrs_.output_),(sizeof(double)));
};
        CS_=sizeof(char*)+CS_;;
}break;
case (unsigned char)'\035':{int _len33;
char *_to34;
 mmoveto(&_len33,1+CS_,int );

       mmoveto(&_to34,(1+sizeof(int))+CS_,char *);

       ioptrs_.output_=(-_len33)+ioptrs_.output_;;
       {  memmove((_to34),(ioptrs_.output_),(_len33));
};
       CS_=(sizeof(int)+sizeof(char*))+CS_;;
}break;
case (unsigned char)'\036':{int _len35;
char *_to36;
 ioptrs_.output_=(-sizeof(char*))+ioptrs_.output_;;
       mmoveto(&_len35,1+CS_,int );

       mmoveto(&_to36,ioptrs_.output_,char *);

       ioptrs_.output_=(-_len35)+ioptrs_.output_;;
       {  memmove((_to36),(ioptrs_.output_),(_len35));
};
       CS_=sizeof(int)+CS_;;
}break;
case (unsigned char)'\037':{int _len37;
char *_to38;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;
       mmoveto(&_len37,ioptrs_.output_,int );

       ioptrs_.output_=(-sizeof(char*))+ioptrs_.output_;;
       mmoveto(&_to38,ioptrs_.output_,char *);

       ioptrs_.output_=(-_len37)+ioptrs_.output_;;
       {  memmove((_to38),(ioptrs_.output_),(_len37));
};
}break;
case (unsigned char)'\120':{double _39;
double _40;
 ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;
      mmoveto(&_39,(-sizeof(double))+ioptrs_.output_,double );mmoveto(&_40,ioptrs_.output_,double );{double temp=_39+_40;mmovefrom(&temp, (-sizeof(double))+ioptrs_.output_
      ,double );}
}break;
case (unsigned char)'\121':{double _41;
double _42;
 ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;
      mmoveto(&_41,(-sizeof(double))+ioptrs_.output_,double );mmoveto(&_42,ioptrs_.output_,double );{double temp=_41-_42;mmovefrom(&temp, (-sizeof(double))+ioptrs_.output_
      ,double );}
}break;
case (unsigned char)'\122':{double _43;
double _44;
 ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;
      mmoveto(&_43,(-sizeof(double))+ioptrs_.output_,double );mmoveto(&_44,ioptrs_.output_,double );{double temp=_43*_44;mmovefrom(&temp, (-sizeof(double))+ioptrs_.output_
      ,double );}
}break;
case (unsigned char)'\123':{double _45;
double _46;
 ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;
      mmoveto(&_45,(-sizeof(double))+ioptrs_.output_,double );mmoveto(&_46,ioptrs_.output_,double );{double temp=_45/_46;mmovefrom(&temp, (-sizeof(double))+ioptrs_.output_
      ,double );}
}break;
case (unsigned char)'\124':{double _47;
 ioptrs_.output_=(-sizeof(double))+ioptrs_.output_;
       mmoveto(&_47,ioptrs_.output_,double ); fprintf(stdout,"%g",_47 );fflush(stdout);
}break;
case (unsigned char)'\125':{int _48;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
       mmoveto(&_48,ioptrs_.output_,int );{double temp=(double)(_48);mmovefrom(&temp, ioptrs_.output_  ,double );}
       ioptrs_.output_=sizeof(double)+ioptrs_.output_;
}break;
case (unsigned char)'\151':{  CS_=1+CS_;;  {do{(*(ioptrs_.output_))=(*(CS_));  ioptrs_.output_=1+ioptrs_.output_;;  CS_=1+CS_;;   }while(!((*(CS_))=='\000'));}
}break;
case (unsigned char)'\152':{ (*(ioptrs_.output_))='\000';  ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
        fprintf(stdout,"%0.*s",300000-1+((signed)(buffer_-ioptrs_.output_))-(0)+1,ioptrs_.output_ +0);fflush(stdout);
}break;
case (unsigned char)'\153':{ fflush(stdout);
}break;
case (unsigned char)'\134':{double _49;
 mmoveto(&_49,(-sizeof(double))+ioptrs_.output_,double );{double temp= -_49;mmovefrom(&temp, (-sizeof(double))+ioptrs_.output_,double );}
}break;
case (unsigned char)'\135':{double _50;
 mmoveto(&_50,(-sizeof(double))+ioptrs_.output_,double );{double temp=fabs(_50);mmovefrom(&temp, (-sizeof(double))+ioptrs_.output_,double );}

}break;
case (unsigned char)'0':{ A_=0;  }goto intops;
case (unsigned char)'1':{ A_=1;  }goto intops;
case (unsigned char)'2':{ A_=2;  }goto intops;
case (unsigned char)'3':{ A_=3;  }goto intops;
case (unsigned char)'4':{ A_=4;  }goto intops;
case (unsigned char)'8':{ A_=8;  }goto intops;
case (unsigned char)'\010':{ mmoveto(&A_,1+CS_,int );
       CS_=sizeof(int)+CS_;;
       }goto intops;
case (unsigned char)'\020':{char *_from51;
int _52;
 mmoveto(&_52,1+CS_,int );_from51=(_52)+_FP3;

	mmoveto(&A_,_from51,int );
	CS_=sizeof(int)+CS_;;
        }goto intops;
case (unsigned char)'\023':{char *_from53;
 mmoveto(&_from53,1+CS_,char *);

	mmoveto(&A_,_from53,int );
        CS_=sizeof(char*)+CS_;;
	}goto intops;
case (unsigned char)'\110':{int _size54;
 mmoveto(&_size54,1+CS_,int );

     CS_=sizeof(int)+CS_;;
     ioptrs_.output_=(-2*_size54)+ioptrs_.output_;
     A_=(ioptrs_.output_ == ioptrs_.output_);
     }goto intops;
case (unsigned char)'\111':{int _size55;
 mmoveto(&_size55,1+CS_,int );

     CS_=sizeof(int)+CS_;;
     ioptrs_.output_=(-2*_size55)+ioptrs_.output_;
     A_=(ioptrs_.output_ != ioptrs_.output_);
     }goto intops;
case (unsigned char)'\112':{double _56;
double _57;
 ioptrs_.output_=(-2*sizeof(double))+ioptrs_.output_;
     mmoveto(&_56,ioptrs_.output_ ,double );mmoveto(&_57,sizeof(double)+ioptrs_.output_,double );A_=(_56>_57);
     }goto intops;
case (unsigned char)'\113':{double _58;
double _59;
 ioptrs_.output_=(-2*sizeof(double))+ioptrs_.output_;
     mmoveto(&_58,ioptrs_.output_ ,double );mmoveto(&_59,sizeof(double)+ioptrs_.output_,double );A_=(_58>=_59);
     }goto intops;
case (unsigned char)'\114':{double _60;
double _61;
 ioptrs_.output_=(-2*sizeof(double))+ioptrs_.output_;
     mmoveto(&_60,ioptrs_.output_ ,double );mmoveto(&_61,sizeof(double)+ioptrs_.output_,double );A_=(_60<_61);
     }goto intops;
case (unsigned char)'\115':{double _62;
double _63;
 ioptrs_.output_=(-2*sizeof(double))+ioptrs_.output_;
     mmoveto(&_62,ioptrs_.output_ ,double );mmoveto(&_63,sizeof(double)+ioptrs_.output_,double );A_=(_62<=_63);
     }goto intops;

default:{
    ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;
    mmoveto(&A_,ioptrs_.output_,int );
    CS_= -1+CS_;;
intops:
    _Alive:{
    CS_=1+CS_;;
    switch( (unsigned char)(*(CS_) )){
    case (unsigned char)'\016':{ ioptrs_.output_=A_+ioptrs_.output_;;
	  goto Alive;
    }break;
case (unsigned char)'\006':{ {void *temp=malloc(A_);mmovefrom(&temp, ioptrs_.output_,void *);}
	  ioptrs_.output_=sizeof(void*)+ioptrs_.output_;;
	  goto Alive;
    }break;
case (unsigned char)'\030':{char *_to64;
int _65;
 mmoveto(&_65,1+CS_,int );_to64=(_65)+_FP3;

            mmovefrom(&A_, _to64,int );
            CS_=sizeof(int)+CS_;;
	    goto Alive;
    }break;
case (unsigned char)'\033':{char *_to66;
 mmoveto(&_to66,1+CS_,char *);

            mmovefrom(&A_, _to66,int );
            CS_=sizeof(char*)+CS_;;
	    goto Alive;
    }break;
case (unsigned char)'\140':{ if( A_!=0 ){ 
          CS_=sizeof(int)+CS_;
        }else{ int _67;
mmoveto(&_67,(1+CS_),int );CS_=(_67)+CS_;};
	goto Alive;
    }break;
case (unsigned char)'\141':{ if( A_==0 ){ 
          CS_=sizeof(int)+CS_;
        }else{ int _68;
mmoveto(&_68,(1+CS_),int );CS_=(_68)+CS_;};
	goto Alive;
    }break;
case (unsigned char)'\142':{ if( A_!=0 ){ 
          CS_=sizeof(int)+CS_;  goto Alive;
        }else{ int _69;
mmoveto(&_69,(1+CS_),int );CS_=(_69)+CS_;};
    }break;
case (unsigned char)'\143':{ if( A_==0 ){ 
          CS_=sizeof(int)+CS_;  goto Alive;
        }else{ int _70;
mmoveto(&_70,(1+CS_),int );CS_=(_70)+CS_;};
    }break;
case (unsigned char)'\100':{int _71;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
         mmoveto(&_71,ioptrs_.output_,int );A_=(_71==A_);
    }break;
case (unsigned char)'\101':{int _72;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
         mmoveto(&_72,ioptrs_.output_,int );A_=(_72!=A_);
    }break;
case (unsigned char)'\102':{int _73;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
         mmoveto(&_73,ioptrs_.output_,int );A_=(_73>A_);
    }break;
case (unsigned char)'\103':{int _74;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
         mmoveto(&_74,ioptrs_.output_,int );A_=(_74>=A_);
    }break;
case (unsigned char)'\104':{int _75;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
         mmoveto(&_75,ioptrs_.output_,int );A_=(_75<A_);
    }break;
case (unsigned char)'\105':{int _76;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
         mmoveto(&_76,ioptrs_.output_,int );A_=(_76<=A_);
    }break;
case (unsigned char)'\040':{int _77;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_77,ioptrs_.output_,int );A_=_77+A_;
    }break;
case (unsigned char)'\041':{int _78;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_78,ioptrs_.output_,int );A_=_78-A_;
    }break;
case (unsigned char)'\042':{int _79;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_79,ioptrs_.output_,int );A_=_79*A_;
    }break;
case (unsigned char)'\043':{int _80;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_80,ioptrs_.output_,int );A_=(_80 / A_);
    }break;
case (unsigned char)'\044':{int _81;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_81,ioptrs_.output_,int );A_=(_81 % A_);
    }break;
case (unsigned char)'\045':{int _82;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_82,ioptrs_.output_,int );A_=(_82 & A_);
    }break;
case (unsigned char)'\046':{int _83;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_83,ioptrs_.output_,int );A_=(_83 | A_);
    }break;
case (unsigned char)'\047':{int _84;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_84,ioptrs_.output_,int );A_=(_84 ^ A_);
    }break;
case (unsigned char)'\050':{int _85;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_85,ioptrs_.output_,int );A_=(_85 >> A_);
    }break;
case (unsigned char)'\051':{int _86;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;
	  mmoveto(&_86,ioptrs_.output_,int );A_=(_86 << A_);
    }break;
case (unsigned char)'\054':{char *_87;
 mmoveto(&_87,(-sizeof(char*))+ioptrs_.output_,char *);{char *temp=A_+_87;mmovefrom(&temp, (-sizeof(char*))+ioptrs_.output_
             ,char *);}
             goto Alive;
    }break;
case (unsigned char)'\055':{int _88;
int _89;
int _90;
int _91;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;
             mmoveto(&_88,1+CS_,int );mmoveto(&_89,ioptrs_.output_,int );mmoveto(&_90,1+CS_,int );mmoveto(&_91,ioptrs_.output_,int );A_=A_*_90+_91;
	     CS_=sizeof(int)+CS_;;
    }break;
case (unsigned char)'\056':{int _92;
char *_93;
 mmoveto(&_92,1+CS_,int );mmoveto(&_93,(-sizeof(char*))+ioptrs_.output_,char *);{char *temp=(_92*A_)+_93;mmovefrom(&temp, (-sizeof(char*))+ioptrs_.output_
	         ,char *);}
                 CS_=sizeof(int)+CS_;;
                 goto Alive;
    }break;
case (unsigned char)'\136':{int _94;
int _96;
 ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;
        mmoveto(&_94,ioptrs_.output_ ,int );if( A_ >_94){ int _95;
mmoveto(&_95,ioptrs_.output_,int ); fprintf(stdout,"""RTCHECKS:: index " "%d"" > ubound " "%d",A_ ,_95);putc('\n',stdout); mmoveto(&A_,ioptrs_.output_,int );};
	ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;
	mmoveto(&_96,ioptrs_.output_ ,int );if( A_ <_96){ int _97;
mmoveto(&_97,ioptrs_.output_,int ); fprintf(stdout,"""RTCHECKS:: index " "%d"" < lbound " "%d",A_ ,_97);putc('\n',stdout); mmoveto(&A_,ioptrs_.output_,int );};
    }break;
case (unsigned char)'\052':{  fprintf(stdout,"%d",A_ );fflush(stdout);
           goto Alive;
    }break;
case (unsigned char)'\053':{  {sprintf(ioptrs_.output_,"%d",A_);}
	   {do{ioptrs_.output_  =1+ioptrs_.output_;;}while(!((*(ioptrs_.output_))=='\000'));}
	   goto Alive;
    }break;
case (unsigned char)'\130':{ A_=(A_==0);
    }break;
case (unsigned char)'\131':{ A_= -A_;
    }break;
case (unsigned char)'\132':{ A_= ~ A_;
    }break;
case (unsigned char)'\133':{ A_=abs(A_);
    }break;
default:{
      mmovefrom(&A_, ioptrs_.output_,int );
      ioptrs_.output_=sizeof(int)+ioptrs_.output_;
      CS_= -1+CS_;;
      goto Alive;
    }};
     goto _Alive;} Alive:;
}};
 goto _go;} go:;
RESULT_=CS_;
memcpy(&errorhook,&_eh4,sizeof(jmp_buf));};return RESULT_;}

int DisplayLevel_;
int StopLevel_;
int TraceLevel_;
char curpos_[sizeof(int)*20];

/*!(
SUBROUTINE HideCursor;
VAR
  R    : Registers;
BEGIN
  R.AH := 1;
  R.CX := 2000H;
  Intr(R,10H);
END HideCursor;

SUBROUTINE ShowCursor;
VAR
  R    : Registers;
BEGIN
  R.AX := 130;
  Intr(R,10H);
END ShowCursor;
!)*/

void fri_3WrStr(char *s_){
  while(!( (((*(s_))=='\000') )||( (ioptrs_.output_>(300000-1)+buffer_)))){
    (*(ioptrs_.output_))=(*(s_));
    ioptrs_.output_=1+ioptrs_.output_;;  s_=1+s_;;
  }
}


void fri_5WrSymbol(char s_,char *color1_,char *color2_,int *curp_){int _6rightstrand(struct item_ *namerec_){int RESULT_;
    if( (*namerec_).son_==&NIL_ ){
      RESULT_=((*(((*namerec_).length_-1)+(*namerec_).body_))==s_);
    }else{
      namerec_=(*namerec_).son_;
      while( namerec_!=&NIL_){
        if( _6rightstrand(namerec_) ){ RESULT_=1; return RESULT_;};
        namerec_=(*namerec_).brother_;
      }
      RESULT_=0;
    };
  return RESULT_;}

  

  if( ((unsigned char)s_>=(unsigned char)'\040')&&( (unsigned char)s_<=(unsigned char)'\176')){
    if( (ioptrs_.output_>(*(char **)(ioptrs_.parstack_) ))&&( (*( -1+ioptrs_.output_))=='#' )){
      {
  (*(ioptrs_.output_))=(s_);  ioptrs_.output_=1+ioptrs_.output_;;
}; {
  (*(ioptrs_.output_))=(' ');  ioptrs_.output_=1+ioptrs_.output_;;
}; (*curp_)+=2;;
    }else{ 
      fri_3WrStr(color1_); {
  (*(ioptrs_.output_))=(s_);  ioptrs_.output_=1+ioptrs_.output_;;
}; (*curp_)+=1;;
    };  
  }else{
    if( (ioptrs_.output_>(*(char **)(ioptrs_.parstack_) ))&&( (*( -1+ioptrs_.output_))!=' ' )){ {
  (*(ioptrs_.output_))=(' ');  ioptrs_.output_=1+ioptrs_.output_;;
}; (*curp_)+=1;;};
    fri_3WrStr(color2_);
    switch( (unsigned char)s_ ){
    case (unsigned char)'\011':{ fri_3WrStr("\033""[37m" "\033""[7m" "<tab> " "\033""[0m"); (*curp_)+=6;;
    }break;
case (unsigned char)'\012':{ fri_3WrStr("\033""[37m" "\033""[7m" "<-" "\033" "[0m" " "); (*curp_)+=3;;
    }break;
case (unsigned char)'\015':{ 
    }break;
case (unsigned char)'\345':{ {
  (*(ioptrs_.output_))=('^');  ioptrs_.output_=1+ioptrs_.output_;;
};  (*curp_)+=1;;
    }break;
case (unsigned char)'\355':{
    }break;
case (unsigned char)'\376':{ fri_3WrStr("] ");  (*curp_)+=2;;
    }break;
case (unsigned char)'\346':{ {
  (*(ioptrs_.output_))=('#');  ioptrs_.output_=1+ioptrs_.output_;;
};  (*curp_)+=1;;
    }break;
case (unsigned char)'\350':{ fri_3WrStr("--");  (*curp_)+=2;;
  /*! per evitare l'aggiunta di uno spazio  */
  /*!!! save non viene tradotto automaticamente !!!  */
  /*!  save: WrStr("]->"); INC curp,3*/
  /*!!!!!!!!!!!!!! ma perche'? !!!!!!!!!!!!!!!!!!!!*/
    }break;
default:{struct item_ *namerec_;
      
      namerec_=(*(struct item_ **)(((unsigned char)'\200')*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));
        {do{while(!( _6rightstrand(namerec_))){
          namerec_=(*namerec_).brother_; 
          if( namerec_==&NIL_ ){
            fri_3WrStr("CHAR(");  {sprintf(ioptrs_.output_,"%d",(unsigned char)s_);}
            while( (unsigned char)(*(ioptrs_.output_))!=0){  ioptrs_.output_=1+ioptrs_.output_;;  (*curp_)+=1;;  }
            {
  (*(ioptrs_.output_))=(')');  ioptrs_.output_=1+ioptrs_.output_;;
}; (*curp_)+=6;; 
            goto buildname;
          };
        }
         {int i_=0  ;while(i_<=(*namerec_).length_-1){
          if( ((unsigned char)(*(i_+(*namerec_).body_))<(unsigned char)' ')||( (unsigned char)(*(i_+(*namerec_).body_))>(unsigned char)'\177')){ goto buildname;};
          {
  (*(ioptrs_.output_))=((*(i_+(*namerec_).body_)));  ioptrs_.output_=1+ioptrs_.output_;;
};  (*curp_)+=1;; 
        i_+=1;};}
        namerec_=(*namerec_).son_;
       }while(!(namerec_==&NIL_));buildname:;}
      {
  (*(ioptrs_.output_))=(' ');  ioptrs_.output_=1+ioptrs_.output_;;
};  (*curp_)+=1;;
    }};
  };
}

void fri_6TraceLine(char *p_,char *begin_,char *endl_,int col_){  
    
    
      char *linestart_;
char *l_;
  int cp_;
int cpp_;
  
  if( begin_>=endl_ ){ return;};
  linestart_=p_;
  cp_=col_;
  ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
  {do{fri_5WrSymbol((*(linestart_)),"\033""[36m","\033""[36m",&cp_);
    linestart_= -1+linestart_;;
   }while(!(((((*(linestart_))=='\012') )||( (cp_>80) ))||( (linestart_<begin_))));}
  {do{l_=linestart_;
    cp_=col_;
    cpp_=81;
    ioptrs_.output_=(*(char **)(ioptrs_.parstack_));
    {do{l_=1+l_;;
      if( l_==p_ ){
        cpp_=cp_;
        fri_5WrSymbol((*(l_)),"\033""[37m","\033""[37m",&cp_);
        cpp_=((cp_+cpp_-1) / 2);
      }else{
        fri_5WrSymbol((*(l_)),"\033""[33m","\033""[36m",&cp_);
      };
     }while(!(((cp_>80 )||( l_>= -1+endl_))||( (*(l_))=='\012')));}
    linestart_=1+linestart_;;
   }while(!(((cpp_<=50 )||( cp_<=80 ))||( linestart_>=endl_)));}
  (*(ioptrs_.output_))='\000';
   fprintf(stdout,"""\033""[" "%dG%s""\033""[37m" "\033" "[K""",col_  ,(*(char **)(ioptrs_.parstack_) ));putc('\n',stdout);
   fprintf(stdout,"""\033""[K" "\033" "[" "%d""G""^" "\033" "[K""",cpp_ );putc('\n',stdout);
  ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
}

void fri_7TraceInputLine(){
   fprintf(stdout,"""\015""\033""[32m" "In line " "\033""[37m" "%d""\033""[32m" ":    " "",ioptrs_.input_.ln_ );fflush(stdout);
  if( ioptrs_.input_.pos_<0 ){
char *begin_;
    int _8;
    begin_=(300000+inpstack_)+buffer_;while( mmoveto(&_8,begin_,int ),_8<ioptrs_.input_.pos_){int _9;

      mmoveto(&_9,begin_,int );begin_=(300000+_9)+buffer_;
    }
    fri_6TraceLine((300000+ioptrs_.input_.pos_)+buffer_,4+begin_,(300000+ioptrs_.input_.iend_)+buffer_,15);
  }else{
    if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
    fri_6TraceLine(ioptrs_.input_.pos_+bufstart_,1+ibuf_,inputend_+bufstart_,15);
  };
   fprintf(stdout,"""\033""[A" "\033""[32m" "of " "\033""[37m" "%s""\033""[32m" ":" "\033""[37m""",(*(char **)(curfile_*sizeof(char*)+ifname_-sizeof(char*)) ));putc('\n',stdout);
}

void fri_8TraceInit(char s_){
  if( (unsigned char)s_==0 ){
    single_char_input();
     fprintf(stdout,"""\033""[?7l" "\033" "[2J" "");putc('\n',stdout);
    TraceLevel_=1;  StopLevel_=INT_MAX;
  }else{
    TraceLevel_+=1;;
  };
  if( TraceLevel_<=18 ){ DisplayLevel_=TraceLevel_;};
   fprintf(stdout,"""\033""[" "%dH",4+DisplayLevel_  );fflush(stdout);
  switch( (unsigned char)s_ ){
  case 0:{  fprintf(stdout,"""\033""[32m" "tracing: " "");fflush(stdout);  (*(int *)(DisplayLevel_*sizeof(int)+curpos_-sizeof(int)))=10;
  }break;
case 1:{ (*(int *)(DisplayLevel_*sizeof(int)+curpos_-sizeof(int)))=1;
  }break;
default:{
    (*(int *)(DisplayLevel_*sizeof(int)+curpos_-sizeof(int)))=1;
    ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
    fri_5WrSymbol(s_,"\033""[32m","\033""[32m",(int *)(DisplayLevel_*sizeof(int)+curpos_-sizeof(int)));
    (*( -1+ioptrs_.output_))='\000';
     fprintf(stdout,"%s"": " "",(*(char **)(ioptrs_.parstack_) ));fflush(stdout);  (*(int *)(DisplayLevel_*sizeof(int)+curpos_-sizeof(int)))+=1;;
    ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
  }};
}

void fri_9TraceOut(){
   fprintf(stdout,"""\033""[?7h" "\033""[37m" "");fflush(stdout);
  restore_termios();
}

void fri_10Trace(struct item_ *curpat_,char *CS_,char *CSend_,int ANDcut_){char c_;
  
  /*! IF CS[0]>=32 AND CS[0]<=127 THEN EXIT Trace*/
  if( TraceLevel_>=StopLevel_ ){ return;};
   fprintf(stdout,"""\033""[H" "");fflush(stdout);
  fri_7TraceInputLine();
   fprintf(stdout,"""\033""[32m" "output: " "");fflush(stdout);
  fri_6TraceLine( -1+ioptrs_.output_,(*(char **)(ioptrs_.parstack_)),ioptrs_.output_,9);
   fprintf(stdout,"""\033""[4H" "\033""[37m" "%d-%c-%d-%d-%d ",256-(unsigned char)curscope_  ,ANDcut_ ?'Y':'N' ,((signed)(ioptrs_.output_-buffer_))-inpstack_  ,((signed)(ioptrs_.parstack_-bufmark_))/(signed)sizeof(char*) ,seqn_ );putc('\n',stdout);
   fprintf(stdout,"""\033""[" "%dH",4+DisplayLevel_  );fflush(stdout);
  fri_6TraceLine(CS_,( curpat_!=&NIL_  ?(*curpat_).body_  :buffer_),CSend_,(*(int *)(DisplayLevel_*sizeof(int)+curpos_-sizeof(int))));
   fprintf(stdout,"""\033""[J" "");fflush(stdout);
  if( read(STDIN_FILENO,(char *)&c_,1)!=0 ){
    switch( (unsigned char)c_ ){
    case (unsigned char)'\003':case (unsigned char)'Q':case (unsigned char)'q':{ fri_9TraceOut();  exit( -1);
    }break;
case (unsigned char)'C':case (unsigned char)'c':{ fri_9TraceOut();  TraceOn_=0;  return;
    }break;
case (unsigned char)'P':case (unsigned char)'p':{  {do{sleep(1);}while(!(read(STDIN_FILENO,(char *)&c_,1)!=0));}
    }break;
case (unsigned char)'\011':{ StopLevel_=TraceLevel_;
    }break;
};
  }else{
    if( (unsigned char)(*(CS_))>127 ){ switch( (unsigned char)(*(CS_) )){
    case (unsigned char)'\347':case (unsigned char)'\350':case (unsigned char)'\351':case (unsigned char)'\353':case (unsigned char)'\352':case (unsigned char)'\354':case (unsigned char)'\372':case (unsigned char)'\361':case (unsigned char)'\376':{
    }break;
default:{ sleep(1);
    }};};
  };  
}

void fri_11TraceEnd(){
  if( TraceLevel_>1 ){ TraceLevel_-=1;;};
  if( TraceLevel_<=18 ){ DisplayLevel_=TraceLevel_;};
  if( (TraceLevel_==1 )||( TraceLevel_<StopLevel_ )){ StopLevel_=INT_MAX;};
}

void fri_12ErrorMessage(struct item_ *pattern_,char *CS_,char *CSend_){struct inps_ saveinput_;
  
  if( (CS_>=CSend_ )&&( (*pattern_).son_!=&NIL_ )){
    pattern_=(*pattern_).son_;
    CS_=(*pattern_).body_;
    CSend_=((*pattern_).length_)+(*pattern_).body_;
  };
  saveinput_=ioptrs_.input_;while( (ioptrs_.input_.pos_<0 )&&( (((unsigned char)(*((300000+ioptrs_.input_.pos_)+buffer_))>=(unsigned char)'\177')||( ioptrs_.input_.pos_<inpstack_)))){
    mmoveto(&ioptrs_.input_ ,(300000+ioptrs_.input_.iend_)+buffer_,struct inps_ ); 
  }
   fprintf(stdout,"""\033""[?7l" "");fflush(stdout);
  fri_7TraceInputLine();
   fprintf(stdout,"""\033""[?7h" "*** ERROR: " "");fflush(stdout);
  if( (*(CS_))==('\367') ){
    fri_6TraceLine((*(char **)(ioptrs_.parstack_)),(*(char **)(ioptrs_.parstack_)),ioptrs_.output_,12);
    ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
if( (*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int)))!=STDIN_FILENO ){
char c_;
       fprintf(stdout,"""\033""[A" "\033""[37m" "(Q)uit/(C)ontinue? " "");fflush(stdout);
      single_char_input();
      while(!( read(STDIN_FILENO,(char *)&c_,1)!=0)){ sleep(1);}
      restore_termios();
      switch( (unsigned char)c_ ){
      case (unsigned char)'Q':case (unsigned char)'q':{  exit( -1);
      }break;
};
};
}else{
int cp_;
        if( (*(CS_))==('\357') ){ CS_=1+CS_;; ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;};
    if( (*(CS_))==('\356') ){ CS_=1+CS_;; ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;};
    if( (*(CS_))==('\373') ){ CS_=1+CS_;;};
    if( (*(CS_))==('\371') ){ while(!( ((*( -1+CS_))==('\356') )||( CS_==(*pattern_).body_))){ CS_= -1+CS_;;}};
    cp_=1;ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
    
      {do{switch( (unsigned char)(*(CS_) )){
      case (unsigned char)'\346':{
        CSend_=(*(char **)((-((unsigned char)(*(1+CS_))-(unsigned char)'0'))*sizeof(char*)+ioptrs_.parstack_));
        CS_= -1+(*(char**)((-((unsigned char)(*(1+CS_))-(unsigned char)'0')-1)*sizeof(char*)+ioptrs_.parstack_));
      }break;
case (unsigned char)'\000': case (unsigned char)'\347': case (unsigned char)'\377':{
      }break;
case (unsigned char)'\344':{ {
  (*(ioptrs_.output_))=(' ');  ioptrs_.output_=1+ioptrs_.output_;;
}; cp_+=1;;
      }break;
default:{
        fri_5WrSymbol((*(CS_)),"\033""[31m","\033""[31m",&cp_);
      }};
      CS_=1+CS_;;
     }while(!((CS_>=CSend_ )||( ((unsigned char)(*(CS_))>(unsigned char)'\342')&&( (*(CS_))!=('\346')))));builderror:;}
    (*(ioptrs_.output_))='\000';
     fprintf(stdout,"%s""\033""[37m" " expected.""",(*(char **)(ioptrs_.parstack_) ));putc('\n',stdout);
    ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
    exit( -1);
  };
  ioptrs_.input_=saveinput_;
}

void fri_7SystemError(char *s_){
   fprintf(stdout,"""\033""[?7l" "\033" "[2J" "");fflush(stdout);
  fri_7TraceInputLine();
   fprintf(stdout,"""\033""[4;" "%d""H*** internal FRI error: " "%s"". ***""",((58-strlen(s_))/ 2 ),s_ );putc('\n',stdout);
  /*! IF outfile>0 AND output>parstack[0] THEN WriteOut*/
   fprintf(stdout,"""\033""[?7h" "\033""[37m""");putc('\n',stdout);
  exit( -1);
} 

int  ca13[]={0,1,2,3,4,5,6,7,8,9,0,0,0,0,0,0,0,10,11,12,13,14,15};
void fri_14SortedInsert(struct item_ **loc_,char *buf_,int buflength_,char bufscope_){int count_;
int pos_;
int pos1_;
struct item_ **loc1_;

count_=0;pos_=0;pos1_=0;(*(buflength_+buf_))=('\376');
loc1_=loc_;_sort:{char lpos_;
  char bpos_;
  
  if( (*loc_)==&NIL_ ){ goto sort;};
  lpos_=(*(pos_+(*(*loc_)).body_));if( pos_==(*(*loc_)).length_ ){
    if( (*(*loc_)).length_==0 ){ goto sort;};
    if( (*(*loc_)).son_==&NIL_ ){ lpos_='\377' ;}else{
      if( (unsigned char)(*(*loc_)).scope_>(unsigned char)bufscope_ ){ (*(*loc_)).scope_=bufscope_;};
      loc_=&(*(*loc_)).son_;  loc1_=loc_;  buf_=pos_+buf_;  buflength_-=pos_;
      if( (count_>0 )&&( (*((pos1_-pos_)+buf_))==('\356') )){ goto sort;};
      pos_=0;  pos1_=0;  count_=0;
      lpos_=(*(pos_+(*(*loc_)).body_));  if( (*(*loc_)).length_==0 ){ lpos_='\377';};
    };
  };
  if( (pos_>buflength_ )||( pos_>(*(*loc_)).length_ )){ fri_7SystemError("duplicate definition");};
  bpos_=(*(pos_+buf_));if( bpos_==lpos_ ){
    switch( (unsigned char)bpos_ ){
    case (unsigned char)'\347':{ if( (((*((pos_+1)+buf_))!=(*((pos_+1)+(*(*loc_)).body_) ))||( (*((pos_+2)+buf_))!=(*((pos_+2)+(*(*loc_)).body_)))) ){ count_=1;};
    }break;
case (unsigned char)'\350':case (unsigned char)'\360':case (unsigned char)'\355':case (unsigned char)'\345':{ if( (*((pos_+1)+buf_))!=(*((pos_+1)+(*(*loc_)).body_) )){ count_=1;};
    }break;
case (unsigned char)'\356':{ count_=1;
    }break;
case (unsigned char)'\177':case (unsigned char)'\354':case (unsigned char)'\357':case (unsigned char)'\365':case (unsigned char)'\366':case (unsigned char)'\367':case (unsigned char)'\371':case (unsigned char)'\376':{ count_=0;
    }break;
case (unsigned char)'\364':case (unsigned char)'\363':{ if( (*((pos_+1)+buf_))!=(*((pos_+1)+(*(*loc_)).body_) )){ count_=1 ;}else{ count_=0;};
    }break;
};
    pos_+=1;;
    if( count_==0 ){ pos1_=pos_;};
  }else{
    if( pos1_>0 ){
      fri_5SplitItem(loc_,pos1_);
      if( (unsigned char)(*(*loc_)).scope_>(unsigned char)bufscope_ ){ (*(*loc_)).scope_=bufscope_;};
      loc_=&(*(*loc_)).son_;  loc1_=loc_;  buf_=pos1_+buf_;  buflength_-=pos1_;
      pos_-=pos1_;  pos1_=0;
    };
    if( ((unsigned char)lpos_>(unsigned char)bpos_ )&&( pos_==0 )){
      goto sort;
    }else{
      loc_=&(*(*loc_)).brother_;  if( pos_==0 ){ loc1_=loc_;};
      pos_=0;  pos1_=0;  count_=0;
    };
  };
 goto _sort;} sort:;
fri_3NewItem(loc1_,buf_,buflength_,bufscope_);
}

void fri_15scopedelete(struct item_ **sonlist_){
  
{do{if( (unsigned char)(*(*sonlist_)).scope_>(unsigned char)curscope_ ){ sonlist_=&(*(*sonlist_)).brother_ ;}else{
    if( (*(*sonlist_)).son_!=&NIL_ ){ fri_15scopedelete(&(*(*sonlist_)).son_);};
    if( (*(*sonlist_)).son_==&NIL_ ){ fri_4DisposeItem(sonlist_) ;}else{ sonlist_=&(*(*sonlist_)).brother_;};
  };
 }while(!((*sonlist_)==&NIL_));}
}

void fri_16DeleteScope(){
    {int s_=(unsigned char)'\200';do{
    if( (unsigned char)(*(s_+rootscope_-((unsigned char)'\200')))<=(unsigned char)curscope_ ){
      if( (*(struct item_ **)(s_*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))!=&NIL_ ){ fri_15scopedelete((struct item_ **)(s_*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));};
      (*(s_+rootscope_-((unsigned char)'\200')))=(char)((unsigned char)curscope_+1);
    };  
  s_++;}while(s_<=(unsigned char)'\342');}
  curscope_=(char)((unsigned char)curscope_+1);
}

void fri_17Delete(){struct item_ **pattern_;
struct item_ **p1_;
char *s_;
char *starts_;
char *CS_;
char *CSend_;

if( (((unsigned char)(*((*(char**)ioptrs_.parstack_)))<(unsigned char)'\200') )||( ((unsigned char)(*((*(char**)ioptrs_.parstack_)))>(unsigned char)topstrand_) )){ fri_7SystemError("invalid strand");};
pattern_=(struct item_ **)(((unsigned char)(*(*(char**)ioptrs_.parstack_)))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*)));p1_=pattern_;s_=1+(*(char**)ioptrs_.parstack_);starts_=s_;CS_=(*(*pattern_)).body_;CSend_=((*(*pattern_)).length_)+(*(*pattern_)).body_; while( s_<ioptrs_.output_){
  if( CS_>=CSend_ ){
    if( (*(*pattern_)).son_==&NIL_ ){ goto compareloop;};
    pattern_=&(*(*pattern_)).son_;
    if( (*(*pattern_)).brother_!=&NIL_ ){ p1_=pattern_;};
    CS_=(*(*pattern_)).body_;
    CSend_=((*(*pattern_)).length_)+(*(*pattern_)).body_;
    starts_=s_;
  };
  while( (*(CS_))!=(*(s_))){
    pattern_=&(*(*pattern_)).brother_;
    p1_=pattern_;
    if( (*pattern_)==&NIL_ ){ return;};
    CS_=(*(*pattern_)).body_;
    CSend_=((*(*pattern_)).length_)+(*(*pattern_)).body_;
    s_=starts_;
  }
  s_=1+s_;;  CS_=1+CS_;;
}compareloop:;
if( (unsigned char)(*(*p1_)).scope_<=(unsigned char)curscope_ ){
  if( (*(*p1_)).son_!=&NIL_ ){ fri_15scopedelete(&(*(*p1_)).son_);};
  if( (*(*p1_)).son_==&NIL_ ){ fri_4DisposeItem(p1_);};
};
}

void fri_18WrPattern(struct item_ *head_){
if( head_==&NIL_ ){ fri_8AddBuf((*(char **)(ioptrs_.parstack_))) ;}else{

    char *_saveoutput19;
  _saveoutput19=ioptrs_.output_;

  {do{{  memmove((ioptrs_.output_),((*head_).body_),((*head_).length_));
};  ioptrs_.output_=((*head_).length_)+ioptrs_.output_;;
    fri_18WrPattern((*head_).son_);
    ioptrs_.output_=_saveoutput19;
    head_=(*head_).brother_;
   }while(!(head_==&NIL_));}
};
}

void fri_19List(){struct item_ **pattern_;
char *s_;
char *starts_;
char *CS_;
char *CSend_;

fri_8AddBuf(ioptrs_.output_);
if( (((unsigned char)(*((*(char**)ioptrs_.parstack_)))<(unsigned char)'\200') )||( ((unsigned char)(*((*(char**)ioptrs_.parstack_)))>(unsigned char)topstrand_) )){ fri_7SystemError("invalid strand");};
pattern_=(struct item_ **)(((unsigned char)(*(*(char**)ioptrs_.parstack_)))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*)));s_=1+(*(char**)ioptrs_.parstack_);starts_=s_;CS_=(*(*pattern_)).body_;CSend_=((*(*pattern_)).length_)+(*(*pattern_)).body_; while( s_<ioptrs_.output_){
  if( CS_>=CSend_ ){
    if( (*(*pattern_)).son_==&NIL_ ){ goto compareloop;};
    pattern_=&(*(*pattern_)).son_;
    CS_=(*(*pattern_)).body_;
    CSend_=((*(*pattern_)).length_)+(*(*pattern_)).body_;
    starts_=s_;
  };
  while( (*(CS_))!=(*(s_))){
    pattern_=&(*(*pattern_)).brother_;
    if( (*pattern_)==&NIL_ ){ goto compareloop;};
    CS_=(*(*pattern_)).body_;
    CSend_=((*(*pattern_)).length_)+(*(*pattern_)).body_;
    s_=starts_;
  }
  s_=1+s_;;  CS_=1+CS_;;
}compareloop:;
if( (*pattern_)!=&NIL_ ){
  if( ((signed)(CSend_-CS_))>0 ){ {  memmove((ioptrs_.output_),(CS_),(((signed)(CSend_-CS_))));
}; ioptrs_.output_=((signed)(CSend_-CS_))+ioptrs_.output_;;};
  fri_18WrPattern((*(*pattern_)).son_);
};
ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
}

char *word_;
char *completer_for_readline(char *text_,int state_){char *RESULT_;
if( state_==0 ){
  word_=ioptrs_.output_;
  {
  (*(ioptrs_.output_))=((('\200')));  ioptrs_.output_=1+ioptrs_.output_;;
};  fri_3WrStr(text_);  fri_8AddBuf(word_);
  ioptrs_.output_=word_;
  if( fri_bcode_1Match((*(struct item_ **)(((unsigned char)'\200')*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*)))),(*(*(struct item_ **)(((unsigned char)'\200')*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))).body_,((*(*(struct item_**)(((unsigned char)'\200')*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))).length_)+(*(*(struct item_**)(((unsigned char)'\200')*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))).body_) ){ };
  ioptrs_.output_=word_;
};
if( (*(word_))=='\000' ){ RESULT_=NULL ;}else{
int _len21;
  _len21=strlen(word_)+1;

  RESULT_=malloc(_len21);  strcpy(RESULT_,word_);
  word_=_len21+word_;;
};
return RESULT_;}
/*** {
 char **completion_matches();
 
 return completion_matches (text, completer_for_readline);
 } ununderstood ***/

/*void* rl_completion_entry_function=completer_for_readline;*/


     char **
     fileman_completion (text, start, end)
          char *text;
          int start, end;
     {
       char **completion_matches();
     
         return completion_matches (text, completer_for_readline);
     }

       /* Tell the completer that we want a crack first. */
     void* rl_attempted_completion_function = fileman_completion;

/*void* rl_completion_entry_function=completer_for_readline;*/


     void fri_20Append(struct item_ **l_,char *buf_,char *bufend_){ char savescope_;

if( (*l_)==&NIL_ ){ fri_7SystemError("empty strand");};
savescope_=(*(*l_)).scope_;{do{l_=&(*(*l_)).son_  ;}while(!((*l_)==&NIL_));}
while( buf_<bufend_){char *s_;
  
  s_=buf_;while( ((*(s_))!=('\002') )&&( s_<bufend_)){  s_=1+s_;;  }
  if( s_>buf_ ){ fri_3NewItem(l_,buf_,((signed)(s_-buf_)),savescope_); l_=&(*(*l_)).son_;};
  if( ((*(s_))==('\002') )&&( s_<bufend_ )){
 
        mmoveto(l_,1+s_,struct item_ *);{do{(*(*l_)).scope_=savescope_;  l_=&(*(*l_)).son_  ;}while(!((*l_)==&NIL_));}
  };
  buf_=(sizeof(struct item_*)+1)+s_;
}
}

int fri_bcode_1Match(struct item_ *pattern_,char *CS_,char *CSend_){int RESULT_;void _21rollforward(){
  _rf:{
    if( CS_>=CSend_ ){
      if( (*pattern_).son_==&NIL_ ){ return;};
      pattern_=(*pattern_).son_;
      { CS_=(*pattern_).body_; CSend_=((*pattern_).length_)+(*pattern_).body_;}
    };
    switch( (unsigned char)(*(CS_) )){
    case (unsigned char)'\347':{ CS_=2+CS_;;
    }break;
case (unsigned char)'\350': case (unsigned char)'\345': case (unsigned char)'\360': case (unsigned char)'\363': case (unsigned char)'\364':{ CS_=1+CS_;;
    }break;
case (unsigned char)'\356':{ _inner:{
            CS_=1+CS_;;
            switch( (unsigned char)(*(CS_) )){
            case (unsigned char)'\345':{ CS_=1+CS_;;
}break;
case (unsigned char)'\036':{ CS_=4+CS_;;
}break;
case (unsigned char)'\363':{ CS_=1+CS_;;  goto inner;
            }break;
case (unsigned char)'\177':case (unsigned char)'\354':case (unsigned char)'\357':case (unsigned char)'\364':case (unsigned char)'\365':case (unsigned char)'\366':case (unsigned char)'\367':case (unsigned char)'\371':case (unsigned char)'\376':{ goto inner;
            }break;
};
           goto _inner;} inner:;
    }break;
case (unsigned char)'\353':case (unsigned char)'\352':case (unsigned char)'\351':{ CS_=1+CS_;;  _21rollforward();
    }break;
case (unsigned char)'\376':{ return;
    }break;
};
    CS_=1+CS_;;
   goto _rf;} rf:;
}

int oneonly_;
int ANDcut_;
struct item_ *ORcut_;
struct fri_s6 saveio_;
int _saveinpstack23;
char _savescope24;


if( CS_>=CSend_ ){
  pattern_=(*pattern_).son_;
  { CS_=(*pattern_).body_; CSend_=((*pattern_).length_)+(*pattern_).body_;}
};
oneonly_=(CS_!=(*pattern_).body_);ANDcut_=0;ORcut_=&NIL_;saveio_=ioptrs_;_saveinpstack23=inpstack_ ;

_savescope24=curscope_;

_orloop:{
    
  _andloop:{
    if( CS_>=CSend_ ){
struct item_ *_s25;
      if( CS_>CSend_ ){ fri_7SystemError("unterminated pattern");};
      _s25=(*pattern_).son_;
  if( _s25==&NIL_ ){ goto orloop;};
      if( ANDcut_ ){
        saveio_=ioptrs_;  ORcut_=pattern_;
        pattern_=_s25;  { CS_=(*pattern_).body_; CSend_=((*pattern_).length_)+(*pattern_).body_;}
        ANDcut_=0;  oneonly_=0;
      }else{ if( fri_bcode_1Match(_s25,(*_s25).body_,((*_s25).length_)+(*_s25).body_) ){ 
        goto orloop;
      }else{ goto andloop;};};
    };
    switch( (unsigned char)(*(CS_) )){
    case (unsigned char)'\360':{struct item_ *_s28;
char *_savepar29;
int _done31;
 CS_=1+CS_;;  _s28=(*(struct item_ **)(((unsigned char)(*CS_))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));

          ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
          _savepar29=ioptrs_.parstack_;

          if( TraceOn_ ){ fri_8TraceInit((*(CS_)));};
          _done31=fri_bcode_1Match(_s28,(*_s28).body_,((*_s28).length_)+(*_s28).body_);

          if( TraceOn_ ){ fri_11TraceEnd();};
          if( !_done31 ){ goto andloop;};
          if( (*(char **)(ioptrs_.parstack_))!=(*(char **)(_savepar29) )){
            {  memmove(((*(char **)(_savepar29))),((*(char **)(ioptrs_.parstack_))),(((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))));
};
            ioptrs_.output_=((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))+(*(char**)_savepar29);
          };
          ioptrs_.parstack_= -sizeof(char*)+_savepar29;
          if( ioptrs_.input_.pos_<inpstack_ ){ {
  if( ioptrs_.input_.pos_>=0 ){ fri_7SystemError("input stack is empty");};
  {  memmove((ioptrs_.output_),((300000+ioptrs_.input_.pos_)+buffer_),(ioptrs_.input_.iend_-ioptrs_.input_.pos_-1));
};
  ioptrs_.output_=(ioptrs_.input_.iend_-ioptrs_.input_.pos_-1)+ioptrs_.output_;;
  ioptrs_.input_.pos_=ioptrs_.input_.iend_;  fri_13GetChar();
};};
    }break;
case (unsigned char)'\361':{ oneonly_=0;  ANDcut_=0;
           saveio_=ioptrs_;  ORcut_=pattern_;  pattern_=(*(struct item_ **)(((unsigned char)(*(1+CS_)))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));
           { CS_= -1+(*pattern_).body_; CSend_=((*pattern_).length_)+(*pattern_).body_;}
    }break;
case (unsigned char)'\357':{char *savepar_;
           CS_=1+CS_;;
	  fri_8AddBuf((*(char **)(ioptrs_.parstack_)));  ioptrs_.output_=(*(char **)(ioptrs_.parstack_));
          savepar_=ioptrs_.parstack_;_pipeloop:{
            if( ((unsigned char)ioptrs_.input_.ch_>=(unsigned char)'\200')&&( (unsigned char)ioptrs_.input_.ch_<=(unsigned char)'\343')){
char _c34;
	      _c34=ioptrs_.input_.ch_;
  {
  ioptrs_.input_.pos_+=1;;
  if( ioptrs_.input_.pos_<0 ){
    if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_ ){  
      mmoveto(&ioptrs_.input_,(300000+ioptrs_.input_.iend_)+buffer_,struct inps_ );
    }else{ ioptrs_.input_.ch_=(*((ioptrs_.input_.pos_+300000)+buffer_));};
  }else{
    if( ioptrs_.input_.ch_=='\012' ){ ioptrs_.input_.ln_+=1;;};
    if( ioptrs_.input_.pos_>=inputend_ ){ fri_11Refresh();};
    if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
    ioptrs_.input_.ch_=(char)(((unsigned char)(*(ioptrs_.input_.pos_+bufstart_) )& 127));
    if( ioptrs_.input_.ch_=='\015' ){ /*! skip cr*/
      if( (*(ioptrs_.input_.pos_+bufstart_))=='\215' ){ fri_13GetChar();};
      fri_13GetChar();
    };
  };
};
              if( _c34!=('\343') ){
struct item_ *_p35;
int _failed37;
                if( TraceOn_ ){ fri_8TraceInit(_c34);};
                _p35=(*(struct item_ **)(((unsigned char)_c34)*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));
  _failed37=((_p35==&NIL_) )||( !fri_bcode_1Match(_p35,(*_p35).body_,((*_p35).length_)+(*_p35).body_));

                if( TraceOn_ ){ fri_11TraceEnd();};
                {
  mmoveto(&inpstack_ ,(300000+inpstack_)+buffer_,int ); 
};
                if( _failed37 ){ ioptrs_.parstack_= -sizeof(char*)+savepar_; goto andloop;};
                if( (((*(CS_))==('\371') )&&( CS_<CSend_ ))||(
		   (((*(CS_))==('\356') )&&( (*(1+CS_))==('\371') ))&&( 1+CS_<CSend_ ))){
                  if( (*(char **)(ioptrs_.parstack_))!=(*(char **)(savepar_) )){
                    {  memmove(((*(char **)(savepar_))),((*(char **)(ioptrs_.parstack_))),(((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))));
};
                    ioptrs_.output_=((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))+(*(char**)savepar_);
                  };
                  if( (*(CS_))==('\356') ){ ioptrs_.parstack_=savepar_; CS_ =1+CS_;;}else{ ioptrs_.parstack_= -sizeof(char*)+savepar_;};
                  if( ioptrs_.input_.pos_<inpstack_ ){ {
  if( ioptrs_.input_.pos_>=0 ){ fri_7SystemError("input stack is empty");};
  {  memmove((ioptrs_.output_),((300000+ioptrs_.input_.pos_)+buffer_),(ioptrs_.input_.iend_-ioptrs_.input_.pos_-1));
};
  ioptrs_.output_=(ioptrs_.input_.iend_-ioptrs_.input_.pos_-1)+ioptrs_.output_;;
  ioptrs_.input_.pos_=ioptrs_.input_.iend_;  fri_13GetChar();
};};
                  goto pipeloop;
                };
                fri_8AddBuf((*(char **)(ioptrs_.parstack_)));
              };
            };
            ioptrs_.output_=(*(char **)(savepar_));  ioptrs_.parstack_= -sizeof(char*)+savepar_;
            if( (CS_==CSend_ )&&( (*pattern_).son_==&NIL_ )){ goto orloop;};
            if( ((unsigned char)ioptrs_.input_.ch_<(unsigned char)'\200')||( (unsigned char)ioptrs_.input_.ch_>(unsigned char)'\343')){ CS_= -1+CS_;; goto pipeloop;};
            if( (((((unsigned char)(*(CS_))>(unsigned char)'\342')||( (*(CS_))==ioptrs_.input_.ch_ ))||( CS_==CSend_)) )&&( 
              fri_bcode_1Match(pattern_,CS_,CSend_) )){ goto orloop;};
            ioptrs_.parstack_=savepar_;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
           goto _pipeloop;} pipeloop:;
    }break;
case (unsigned char)'\346':{char *_par38;
 _par38=(-((unsigned char)(*(1+CS_))-(unsigned char)'0'))*sizeof(char*)+ioptrs_.parstack_;

            if( (_par38<bufmark_)||( _par38>=ioptrs_.parstack_ )){ fri_7SystemError("out-of-range fetch");};
            if( (*(char **)(sizeof(char*)+_par38))>(*(char **)(_par38) )){
char *_savepar39;
char *_saveout40;
int _done41;
              if( TraceOn_ ){ fri_8TraceInit(('\346'));};
              _savepar39=ioptrs_.parstack_;
  _saveout40=ioptrs_.output_;

              _done41=((((*((*(char**)_par38)))==ioptrs_.input_.ch_ )||( (unsigned char)(*((*(char**)_par38)))>(unsigned char)'\342')) )&&(
                fri_bcode_1Match(&NIL_,(*(char **)(_par38)),(*(char **)(sizeof(char*)+_par38))) );

              if( TraceOn_ ){ fri_11TraceEnd();};
              if( !_done41 ){ goto andloop;};
              if( (*(char **)(ioptrs_.parstack_))>_saveout40 ){
                {  memmove((_saveout40),((*(char **)(ioptrs_.parstack_))),(((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))));
};
                ioptrs_.output_=((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))+_saveout40;
              };
              ioptrs_.parstack_=_savepar39;
            };
            CS_=1+CS_;;
    }break;
case (unsigned char)'\351':{ if( (((((*(1+CS_))==ioptrs_.input_.ch_ )||( (unsigned char)(*(1+CS_))>(unsigned char)'\342'))||( 1+CS_==CSend_)) )&&(  
             fri_bcode_1Match(pattern_,1+CS_,CSend_) )){ goto andloop;};
           CS_=1+CS_;;
           _21rollforward();
    }break;
case (unsigned char)'\353':{char *_savepar42;
char *_saveout43;
 CS_=1+CS_;;
            _savepar42=ioptrs_.parstack_;
  _saveout43=ioptrs_.output_;

            if( (((((*(CS_))==ioptrs_.input_.ch_ )||( (unsigned char)(*(CS_))>(unsigned char)'\342'))||( CS_==CSend_)) )&&( 
              fri_bcode_1Match(pattern_,CS_,CSend_) )){
              if( (*(char **)(ioptrs_.parstack_))>_saveout43 ){
                {  memmove((_saveout43),((*(char **)(ioptrs_.parstack_))),(((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))));
};
                ioptrs_.output_=((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))+_saveout43;
              };
              ioptrs_.parstack_=_savepar42;
            };
            _21rollforward();
    }break;
case (unsigned char)'\352':{char *_savepar44;
char *saveout_;
             CS_=1+CS_;;
            _savepar44=ioptrs_.parstack_;
  saveout_=ioptrs_.output_;while( (((((*(CS_))==ioptrs_.input_.ch_ )||( (unsigned char)(*(CS_))>(unsigned char)'\342'))||( CS_==CSend_)) )&&(  
              fri_bcode_1Match(pattern_,CS_,CSend_))){
              if( (*(char **)(ioptrs_.parstack_))>saveout_ ){
                {  memmove((saveout_),((*(char **)(ioptrs_.parstack_))),(((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))));
};
                ioptrs_.output_=((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))+saveout_;
              };
              ioptrs_.parstack_=_savepar44;  saveout_=ioptrs_.output_;
            }
            _21rollforward();
    }break;
case (unsigned char)'\354':{int ucount_;
             CS_=1+CS_;;  ucount_=0;while(!( (ucount_<=0 )&&( (*(CS_))==ioptrs_.input_.ch_ ))){
               switch( (unsigned char)ioptrs_.input_.ch_ ){
               case (unsigned char)'\177':{ if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_-1 ){ goto andloop;};
               }break;
case (unsigned char)'\022':{ ucount_ +=1;;
               }break;
case (unsigned char)'\023':{ ucount_-=1;;
	       }break;
case (unsigned char)'\002':{struct item_ *_45;
 mmoveto(&_45,(300000+ioptrs_.input_.pos_)+buffer_,struct item_ *);{struct item_ *temp=_45;mmovefrom(&temp, ioptrs_.output_  ,struct item_ *);}
	             ioptrs_.output_=sizeof(struct item_*)+ioptrs_.output_;;
                     ioptrs_.input_.pos_+=sizeof(struct item_*);;
		     ioptrs_.input_.ch_=(*((300000+ioptrs_.input_.pos_)+buffer_));
               }break;
};
               (*(ioptrs_.output_))=ioptrs_.input_.ch_;  ioptrs_.output_=1+ioptrs_.output_;;  {
  ioptrs_.input_.pos_+=1;;
  if( ioptrs_.input_.pos_<0 ){
    if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_ ){  
      mmoveto(&ioptrs_.input_,(300000+ioptrs_.input_.iend_)+buffer_,struct inps_ );
    }else{ ioptrs_.input_.ch_=(*((ioptrs_.input_.pos_+300000)+buffer_));};
  }else{
    if( ioptrs_.input_.ch_=='\012' ){ ioptrs_.input_.ln_+=1;;};
    if( ioptrs_.input_.pos_>=inputend_ ){ fri_11Refresh();};
    if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
    ioptrs_.input_.ch_=(char)(((unsigned char)(*(ioptrs_.input_.pos_+bufstart_) )& 127));
    if( ioptrs_.input_.ch_=='\015' ){ /*! skip cr*/
      if( (*(ioptrs_.input_.pos_+bufstart_))=='\215' ){ fri_13GetChar();};
      fri_13GetChar();
    };
  };
};
             }
             fri_13GetChar();
    }break;
case (unsigned char)'\371':{ if( (((*(1+CS_))==('\357') )&&( 1+CS_<CSend_ ))&&( ioptrs_.input_.pos_<_saveinpstack23 )){
               inpstack_=_saveinpstack23;
             }else{ {
  if( ioptrs_.input_.pos_>=0 ){ fri_7SystemError("input stack is empty");};
  {  memmove((ioptrs_.output_),((300000+ioptrs_.input_.pos_)+buffer_),(ioptrs_.input_.iend_-ioptrs_.input_.pos_-1));
};
  ioptrs_.output_=(ioptrs_.input_.iend_-ioptrs_.input_.pos_-1)+ioptrs_.output_;;
  ioptrs_.input_.pos_=ioptrs_.input_.iend_;  fri_13GetChar();
};};
    }break;
case (unsigned char)'\373':{ ANDcut_=1;
         if( (ioptrs_.input_.pos_<0 )&&( ioptrs_.input_.pos_>=_saveinpstack23 )){ inpstack_=_saveinpstack23;};
    }break;
case (unsigned char)'\375':{ curscope_=(char)((unsigned char)curscope_-1);
    }break;
case (unsigned char)'\374':{ fri_16DeleteScope();
    }break;
case (unsigned char)'\367':{ fri_12ErrorMessage(pattern_,CS_,CSend_);
    }break;
case (unsigned char)'\366':{ {
if( ((*((-sizeof(struct item_*)-1)+ioptrs_.output_))==('\002') )&&(  -1+(-sizeof(struct item_*))+ioptrs_.output_>=(*(char **)(ioptrs_.parstack_) ))){
struct item_ *l_;
    mmoveto(&l_,(-sizeof(struct item_*))+ioptrs_.output_,struct item_ *);ioptrs_.output_= -1+(-sizeof(struct item_*))+ioptrs_.output_;
  while( l_!=&NIL_){
    if( ((*l_).length_)+ioptrs_.output_>=(300000+inpstack_)+buffer_){
      if( outfile_>0 ){ write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(*(char **)(ioptrs_.parstack_)),((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_))));};
      ioptrs_.output_=(*(char **)(ioptrs_.parstack_));
    };
    {  memmove((ioptrs_.output_),((*l_).body_),((*l_).length_));
};
    ioptrs_.output_=((*l_).length_)+ioptrs_.output_;
    {struct item_ * temp=(*l_).son_;free(l_);l_=temp;};
  }
};
if( outfile_>0 ){ write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(*(char **)(ioptrs_.parstack_)),((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_))));};
};  ANDcut_=1;
    }break;
case (unsigned char)'\365':{ {
   {int i_=1  ;while(i_<=outfile_-1){
    write((*(int *)(i_*sizeof(int)+outputfile_-sizeof(int))),(*(char **)(ioptrs_.parstack_)),((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_))));
  i_+=1;};}
};  ANDcut_=1;
    }break;
case (unsigned char)'\364':{ CS_=1+CS_;;
            fri_20Append((struct item_ **)(((unsigned char)(*CS_))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))),(*(char **)(ioptrs_.parstack_)),ioptrs_.output_);
            ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
            ANDcut_=1;
    }break;
case (unsigned char)'\363':{char _scope46;
 if( (((unsigned char)(*((*(char**)ioptrs_.parstack_)))<(unsigned char)'\200') )||( ((unsigned char)(*((*(char**)ioptrs_.parstack_)))>(unsigned char)topstrand_) )){ fri_7SystemError("invalid strand");};
          CS_=1+CS_;;  _scope46=(*( (unsigned char)(*(CS_))==0  ?&curscope_  :(CS_)));

          if( ioptrs_.output_>(*(char **)(ioptrs_.parstack_) )){
            fri_14SortedInsert((struct item_ **)(((unsigned char)(*(*(char**)ioptrs_.parstack_)))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))),1+(*(char**)ioptrs_.parstack_),((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))-1,_scope46);
            if( (unsigned char)(*(((unsigned char)(*(*(char**)ioptrs_.parstack_)))+rootscope_-((unsigned char)'\200')))>(unsigned char)_scope46 ){ (*(((unsigned char)(*(*(char**)ioptrs_.parstack_)))+rootscope_-((unsigned char)'\200')))=_scope46;};
          };
          ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
          /*! IF curscope=savescope THEN ANDcut=TRUE*/
    }break;
case (unsigned char)'\356':{ ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;
          if( ioptrs_.parstack_>(500-1)*sizeof(char*)+bufmark_){ fri_7SystemError("infinite recursion");};
          (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
          _intoloop:{
            CS_=1+CS_;;
            while( CS_>=CSend_){
              if( (*pattern_).son_==&NIL_ ){ goto orloop;};
              pattern_=(*pattern_).son_;
              { CS_=(*pattern_).body_; CSend_=((*pattern_).length_)+(*pattern_).body_;}
              oneonly_=0;  ANDcut_=1;
            }
            if( TraceOn_ ){ fri_10Trace(pattern_,CS_,CSend_,ANDcut_);};
            switch( (unsigned char)(*(CS_) )){
            case (unsigned char)'\346':{CS_=1+CS_;;
                 if( (*(CS_))==('\346') ){ (*(ioptrs_.output_))=curscope_; ioptrs_.output_=1+ioptrs_.output_; ;}else{
char *par_;
char *par1_;
                                      par_=(-((unsigned char)(*CS_)-(unsigned char)'0'))*sizeof(char*)+ioptrs_.parstack_;
                   par1_=sizeof(char*)+par_;
                   if( (par_<bufmark_)||( (unsigned char)(*(CS_))<(unsigned char)'1')){ fri_7SystemError("out-of-range fetch");};
                   if( (*(char **)(par1_))>(*(char **)(par_) )){
                     if( ((signed)((*(char**)par1_)-(*(char**)par_)))+ioptrs_.output_>(300000-256+inpstack_)+buffer_){ fri_7SystemError("buffer full");};
                     {  memmove((ioptrs_.output_),((*(char **)(par_))),(((signed)((*(char**)par1_)-(*(char**)par_)))));
};
                     ioptrs_.output_=((signed)((*(char**)par1_)-(*(char**)par_)))+ioptrs_.output_;;
                   };
                 };
            }break;
case (unsigned char)'\004':{  seqn_+=1;;
                      {sprintf(ioptrs_.output_,"%d",seqn_);}
                      {do{ioptrs_.output_=1+ioptrs_.output_;  ;}while(!((*(ioptrs_.output_))=='\000'));}
            }break;
case (unsigned char)'\003':{  {sprintf(ioptrs_.output_,"%d",ioptrs_.input_.ln_);}
                    {do{ioptrs_.output_=1+ioptrs_.output_;  ;}while(!((*(ioptrs_.output_))=='\000'));}
            }break;
case (unsigned char)'\345':{ CS_=1+CS_;;
                   (*(ioptrs_.output_))=(*(CS_));  ioptrs_.output_=1+ioptrs_.output_;;
                   if( (*(CS_))==('\345') ){ CS_= -1+CS_;;};
            }break;
case (unsigned char)'\362':{ fri_17Delete();
            }break;
case (unsigned char)'\357':case (unsigned char)'\354':case (unsigned char)'\363':case (unsigned char)'\364':case (unsigned char)'\365':case (unsigned char)'\366':case (unsigned char)'\367':case (unsigned char)'\371':{ CS_= -1+CS_;;  goto intoloop;
            }break;
case (unsigned char)'\177':{ ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;  goto intoloop;
            }break;
case (unsigned char)'\376':{ goto intoloop;
}break;
case (unsigned char)'\034':{ {int temp=((signed)((*(char**)ioptrs_.parstack_)-(*(char**)(-sizeof(char*)+ioptrs_.parstack_))));mmovefrom(&temp, ioptrs_.output_  ,int );}
	            ioptrs_.output_=sizeof(int)+ioptrs_.output_;;
            }break;
case (unsigned char)'\036':{ {  memmove((ioptrs_.output_),(1+CS_),(4));
};  CS_=4+CS_;;  ioptrs_.output_=4+ioptrs_.output_;;
	    /*! INC CS; output[0..3]=CS[0..3]; INC output,4; INC CS,3*/
	    /*! non funziona perche' tradotto in strncpy !*/
}break;
default:{
              (*(ioptrs_.output_))=(*(CS_));  ioptrs_.output_=1+ioptrs_.output_;;
            }};
           goto _intoloop;} intoloop:;
    }break;
case (unsigned char)'\376':{ goto orloop;
    }break;
case (unsigned char)'\372':{   
            int ucount_;
           ucount_=0;{do{switch( (unsigned char)ioptrs_.input_.ch_ ){
            case (unsigned char)'\177':{ if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_-1 ){ goto andloop;};
            }break;
case (unsigned char)'\022':{ ucount_ +=1;;
            }break;
case (unsigned char)'\023':{ ucount_-=1;;
	    }break;
case (unsigned char)'\002':{struct item_ *_48;
 mmoveto(&_48,(300000+ioptrs_.input_.pos_)+buffer_,struct item_ *);{struct item_ *temp=_48;mmovefrom(&temp, ioptrs_.output_  ,struct item_ *);}
	          ioptrs_.output_=sizeof(struct item_*)+ioptrs_.output_;;
                  ioptrs_.input_.pos_+=sizeof(struct item_*);;
		  ioptrs_.input_.ch_=(*((300000+ioptrs_.input_.pos_)+buffer_));
            }break;
};
            (*(ioptrs_.output_))=ioptrs_.input_.ch_;  ioptrs_.output_=1+ioptrs_.output_;;  {
  ioptrs_.input_.pos_+=1;;
  if( ioptrs_.input_.pos_<0 ){
    if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_ ){  
      mmoveto(&ioptrs_.input_,(300000+ioptrs_.input_.iend_)+buffer_,struct inps_ );
    }else{ ioptrs_.input_.ch_=(*((ioptrs_.input_.pos_+300000)+buffer_));};
  }else{
    if( ioptrs_.input_.ch_=='\012' ){ ioptrs_.input_.ln_+=1;;};
    if( ioptrs_.input_.pos_>=inputend_ ){ fri_11Refresh();};
    if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
    ioptrs_.input_.ch_=(char)(((unsigned char)(*(ioptrs_.input_.pos_+bufstart_) )& 127));
    if( ioptrs_.input_.ch_=='\015' ){ /*! skip cr*/
      if( (*(ioptrs_.input_.pos_+bufstart_))=='\215' ){ fri_13GetChar();};
      fri_13GetChar();
    };
  };
};
           }while(!(ucount_<=0));}
    }break;
case (unsigned char)'\370':{ /*!( IF parstack<=0 THEN EXIT andloop !)*/
               ioptrs_.output_=(*(char **)(ioptrs_.parstack_));  ioptrs_.parstack_= -sizeof(char*)+ioptrs_.parstack_;;
    }break;
case (unsigned char)'\362':{ fri_17Delete();
    }break;
case (unsigned char)'\344':{ while( (ioptrs_.input_.ch_==' ' )||( ioptrs_.input_.ch_=='\011')){
              fri_13GetChar();
            }
    }break;
case (unsigned char)'\347':{ if( ((unsigned char)ioptrs_.input_.ch_>(unsigned char)(*(1+CS_) ))&&( (unsigned char)ioptrs_.input_.ch_<(unsigned char)(*(2+CS_) ))){ goto andloop;};
             CS_=2+CS_;;
    }break;
case (unsigned char)'\350':{ CS_=1+CS_;;  if( ioptrs_.input_.ch_==(*(CS_) )){ goto andloop;};
    }break;
case (unsigned char)'\345':{ CS_=1+CS_;;
           if( (*(CS_))!='\000' ){ (*(ioptrs_.output_))=(*(CS_)); ioptrs_.output_=1+ioptrs_.output_;;};
           if( (*(CS_))==('\345') ){ CS_= -1+CS_;;};
    }break;
case (unsigned char)'\355':{ CS_=1+CS_;;
           switch( (unsigned char)(*(CS_) )){
             case (unsigned char)'\002':{struct item_ *l_;
              CS_=1+CS_;;  l_=(*(struct item_ **)(((unsigned char)(*CS_))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))));if( (*l_).length_>1 ){
               {  memmove((ioptrs_.output_),(1+(*l_).body_),((*l_).length_-1));
};
               ioptrs_.output_=((*l_).length_-1)+ioptrs_.output_;
             };
             l_=(*l_).son_ ;
             if( l_!=&NIL_ ){
(*(ioptrs_.output_))=('\002');  ioptrs_.output_=1+ioptrs_.output_;;
               mmovefrom(&l_, ioptrs_.output_  ,struct item_ *);  ioptrs_.output_=sizeof(struct item_*)+ioptrs_.output_;;
               (*(*(struct item_ **)(((unsigned char)(*CS_))*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))).son_=(*l_).brother_;  (*l_).brother_=&NIL_;
};
             }break;
case (unsigned char)'\007':{  TraceOn_= !TraceOn_;  if( TraceOn_ ){ fri_8TraceInit('\000') ;}else{ fri_9TraceOut();};
             }break;
case (unsigned char)'\005':{ if( !fri_16Include() ){ goto andloop;};
             }break;
case (unsigned char)'\017':{int _50;
 {struct stat filed_;  __time_t t1_;
  
  (*(ioptrs_.output_))='\000';
  fstat((*(int *)(curfile_*sizeof(int)+inputfile_-sizeof(int))),&filed_);  t1_=filed_.st_mtime;
   _50 = (stat((*(char **)(ioptrs_.parstack_)),&filed_)==0 )&&( filed_.st_mtime>t1_);
}if( !_50 ){ goto andloop;};
             }break;
case (unsigned char)'\013':{ {
  (*(ioptrs_.output_))='\000';
  outfile_+=1;;  (*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int)))=creat((*(char **)(ioptrs_.parstack_)),0664);
};
             }break;
case (unsigned char)'\014':{ {
  close((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))));  outfile_-=1;;
};
             }break;
case (unsigned char)'\006':{ if( ((unsigned char)ioptrs_.input_.ch_<(unsigned char)'0')||( (unsigned char)ioptrs_.input_.ch_>(unsigned char)'F')){ goto andloop;};
                  (*(ioptrs_.output_))=(char)(16*(*(int *)(((unsigned char)ioptrs_.input_.ch_)*sizeof(int)+((-(unsigned char)'0')*sizeof(int)+((char*)ca13)))));  fri_13GetChar();
                  if( ((unsigned char)ioptrs_.input_.ch_<(unsigned char)'0')||( (unsigned char)ioptrs_.input_.ch_>(unsigned char)'F')){ goto andloop;};
                  (*(ioptrs_.output_))=(char)((unsigned char)(*(ioptrs_.output_))+(*(int *)(((unsigned char)ioptrs_.input_.ch_)*sizeof(int)+((-(unsigned char)'0')*sizeof(int)+((char*)ca13)))));  fri_13GetChar();  ioptrs_.output_=1+ioptrs_.output_;;
             }break;
case (unsigned char)'\001':{if( topstrand_==('\342') ){ fri_7SystemError("too many strands");};
                    topstrand_=(char)((unsigned char)topstrand_+1);
                    (*(ioptrs_.output_))=topstrand_;  ioptrs_.output_=1+ioptrs_.output_;;
             }break;
case (unsigned char)'\016':{ fri_26Increment();
	     
	     }break;
case (unsigned char)'A':{ counter_=0;
	     }break;
case (unsigned char)'B':{ counter_+=1;;
	     }break;
case (unsigned char)'C':{ counter_-=1;;
	     }break;
case (unsigned char)'D':{ (*(ioptrs_.output_))=(char)((unsigned char)'0'-counter_);  ioptrs_.output_=1+ioptrs_.output_;;
	     }break;
case (unsigned char)'E':{ (*( -1+ioptrs_.output_))=(char)((unsigned char)(*( -1+ioptrs_.output_))+counter_);
	     
             }break;
case (unsigned char)'\375':{ {  memmove((ioptrs_.output_),((char *)&seqn_),(sizeof(int)));
};  ioptrs_.output_=sizeof(int)+ioptrs_.output_;;
	     }break;
case (unsigned char)'\374':{ ioptrs_.output_=(-sizeof(int))+ioptrs_.output_;;  {  memmove(((char *)&seqn_),(ioptrs_.output_),(sizeof(int)));
};
             }break;
case (unsigned char)'\020':{ {
  write((*(int *)(outfile_*sizeof(int)+outputfile_-sizeof(int))),(char *)&topstrand_,1);
   {int i_=(unsigned char)'\200' ;do{ fri_22WrTree((*(struct item_ **)(i_*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))) ;i_+=1;}while(i_<=(unsigned char)topstrand_);}
};
             }break;
case (unsigned char)'\021':{ {
  {
  if( ioptrs_.input_.pos_+(1)>=inputend_ ){ fri_11Refresh();};
  if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
  {  memmove((((char *)&topstrand_)),(ioptrs_.input_.pos_+bufstart_),((1)));
};
  ioptrs_.input_.pos_+=(1);
};
   {int i_=(unsigned char)'\200' ;do{ fri_24RdTree((struct item_ **)(i_*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*)))) ;i_+=1;}while(i_<=(unsigned char)topstrand_);}
  ioptrs_.input_.pos_-=1;;  fri_13GetChar();
};
             }break;
case (unsigned char)'\351':{char *_savepar51;
char *_saveout52;
 _savepar51=ioptrs_.parstack_;
  _saveout52=ioptrs_.output_;

		    if( (((((*(1+CS_))==ioptrs_.input_.ch_ )||( (unsigned char)(*(1+CS_))>(unsigned char)'\342'))||( 1+CS_==CSend_)) )&&(  
                    fri_bcode_1Match(pattern_,1+CS_,CSend_) )){
        	      if( (*(char **)(ioptrs_.parstack_))>_saveout52 ){
                	{  memmove((_saveout52),((*(char **)(ioptrs_.parstack_))),(((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))));
};
                	ioptrs_.output_=((signed)(ioptrs_.output_-(*(char**)ioptrs_.parstack_)))+_saveout52;
        	      };
        	      ioptrs_.parstack_=_savepar51;
        	      if( oneonly_ ){ RESULT_=0; return RESULT_; }else{ goto andloop;};
        	    };
		    CS_=1+CS_;;
        	    _21rollforward();
}break;
case (unsigned char)'\025':{ (*(ioptrs_.output_))='\000';
	               if( system((*(char **)(ioptrs_.parstack_)))!=0 ){ goto andloop;};
	     }break;
case (unsigned char)'\026':{ (*(ioptrs_.output_))='\000';
	               curlib_=dlopen((*(char **)(ioptrs_.parstack_)),RTLD_LAZY | RTLD_GLOBAL);
		       if( curlib_==NULL ){ goto andloop;};
		       mmovefrom(&curlib_, ioptrs_.output_,void *);
		       ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
                       ioptrs_.output_=sizeof(void*)+ioptrs_.output_;;
	     }break;
case (unsigned char)'\027':{void *_53;
 ioptrs_.output_=(-sizeof(void*))+ioptrs_.output_;;
	                mmoveto(&_53,ioptrs_.output_,void *);dlclose(_53);
	     }break;
case (unsigned char)'\030':{void *_54;
 (*(ioptrs_.output_))='\000';
	              {void *temp=dlsym(curlib_,(*(char **)(ioptrs_.parstack_)));mmovefrom(&temp, ioptrs_.output_,void *);}
                      mmoveto(&_54,ioptrs_.output_,void *);if( _54==NULL ){ goto andloop;};
		      ioptrs_.parstack_=sizeof(char*)+ioptrs_.parstack_;;  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
                      ioptrs_.output_=sizeof(void*)+ioptrs_.output_;;
	     }break;
case (unsigned char)'\031':{int int_;
        	       (*(ioptrs_.output_))='\000';
        	      sscanf((*(char **)(ioptrs_.parstack_)),(void *)("%d"),&int_);
		      mmovefrom(&int_, (*(char **)(ioptrs_.parstack_)),int );
        	      ioptrs_.output_=sizeof(int)+(*(char**)ioptrs_.parstack_);
	     }break;
case (unsigned char)'\032':{double dbl_;
        	       (*(ioptrs_.output_))='\000';
        	      sscanf((*(char **)(ioptrs_.parstack_)),(void *)("%lg"),&dbl_);
		      mmovefrom(&dbl_, (*(char **)(ioptrs_.parstack_)),double );
        	      ioptrs_.output_=sizeof(double)+(*(char**)ioptrs_.parstack_);
	     }break;
case (unsigned char)'\352':{ CS_=fri_bcode_2bytexec(CS_);
	     }break;
case (unsigned char)'\024':{ {  memmove((ioptrs_.output_),(1+CS_),(((signed)(CSend_-CS_))-1));
};
	               ioptrs_.output_=(((signed)(CSend_-CS_))-1)+ioptrs_.output_;;
                       while( (*pattern_).son_!=&NIL_){
		         pattern_=(*pattern_).son_;
			 {  memmove((ioptrs_.output_),((*pattern_).body_),((*pattern_).length_));
};
			 ioptrs_.output_=((*pattern_).length_)+ioptrs_.output_;;
		       }
		       goto orloop;
             }break;
case (unsigned char)'\035':{ (*(ioptrs_.output_))='\000';
	               if( chdir((*(char **)(ioptrs_.parstack_)))!=0 ){ goto andloop;};
}break;
case (unsigned char)'F':{int dummy_;
	                if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_-1 ){ goto andloop;};
                       dummy_=0;fri_5WrSymbol(ioptrs_.input_.ch_,"\033""[33m","\033""[36m",&dummy_);  fri_13GetChar();
	     }break;
case (unsigned char)'G':{ fri_19List();
           }break;
};
    }break;
default:{
      if( (*(CS_))!=ioptrs_.input_.ch_ ){ goto andloop;};
      {
  ioptrs_.input_.pos_+=1;;
  if( ioptrs_.input_.pos_<0 ){
    if( ioptrs_.input_.pos_>=ioptrs_.input_.iend_ ){  
      mmoveto(&ioptrs_.input_,(300000+ioptrs_.input_.iend_)+buffer_,struct inps_ );
    }else{ ioptrs_.input_.ch_=(*((ioptrs_.input_.pos_+300000)+buffer_));};
  }else{
    if( ioptrs_.input_.ch_=='\012' ){ ioptrs_.input_.ln_+=1;;};
    if( ioptrs_.input_.pos_>=inputend_ ){ fri_11Refresh();};
    if( ioptrs_.input_.pos_+bufstart_<ibuf_){ fri_10moveback();};
    ioptrs_.input_.ch_=(char)(((unsigned char)(*(ioptrs_.input_.pos_+bufstart_) )& 127));
    if( ioptrs_.input_.ch_=='\015' ){ /*! skip cr*/
      if( (*(ioptrs_.input_.pos_+bufstart_))=='\215' ){ fri_13GetChar();};
      fri_13GetChar();
    };
  };
};
    }};
    CS_=1+CS_;;
    if( TraceOn_ ){ fri_10Trace(pattern_,CS_,CSend_,ANDcut_);};
   goto _andloop;} andloop:;
  if( ANDcut_ ){ fri_12ErrorMessage(pattern_,CS_,CSend_);};
  ioptrs_=saveio_;
  {do{pattern_=(*pattern_).brother_;
    if( (oneonly_ )||( pattern_==&NIL_ )){
      if( ORcut_!=&NIL_ ){ 
        { fri_12ErrorMessage(ORcut_,(*ORcut_).body_,((*ORcut_).length_)+(*ORcut_).body_);}
      }else{
        if( (unsigned char)curscope_>(unsigned char)_savescope24 ){ curscope_=_savescope24;};
        while( (unsigned char)curscope_<(unsigned char)_savescope24){ fri_16DeleteScope(); }
        inpstack_=_saveinpstack23;  RESULT_=0;  return RESULT_;
      };
    };
   }while(!((((*((*pattern_).body_))==ioptrs_.input_.ch_ )||( (unsigned char)(*((*pattern_).body_))>(unsigned char)'\342'))||( (*pattern_).length_==0)));}
  { CS_=(*pattern_).body_; CSend_=((*pattern_).length_)+(*pattern_).body_;}
 goto _orloop;} orloop:;
inpstack_=_saveinpstack23;
RESULT_=1;
return RESULT_;}

char *fri_boot21;

int main(int argc, char *argv){
#if defined __linux__
_FPU_SETCW(fpu);
#endif
 if(setjmp(errorhook)){if(ERRORMESSAGE_[0]){fprintf(stderr,"\n%s: PROGRAM HALTED\n",ERRORMESSAGE_);return -1;}else return 0;}else{{void (*sig)(int); if((sig=signal(SIGSEGV,trapsignal))!=SIG_DFL)signal(SIGSEGV,sig); if((sig=signal(SIGFPE,trapsignal))!=SIG_DFL)signal(SIGFPE,sig); if((sig=signal(SIGINT,trapsignal))!=SIG_DFL)signal(SIGINT,sig);}



/*! USE rtchecks*/
/*! #define noacceleration*/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*!! FRI: Formal Rule Interpreter !!*/
/*!! (C) Paolo Luchini 1994-2000  !!*/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*! INCLUDE friadd.pc*/
/*! INCLUDE friadd.unx*/















































































/*! #define stops starcopy,pipe,append,OutBack,Output,ErrOut,copyall*/

{ NIL_.brother_=&NIL_; NIL_.son_=&NIL_; NIL_.scope_='\377' ;NIL_.length_=1; (*(NIL_.body_))=('\376');}

  {int i_=(unsigned char)'\200';do{ (*(struct item_ **)(i_*sizeof(struct item_*)+root_-(((unsigned char)'\200')*sizeof(struct item_*))))=&NIL_ ;i_++;}while(i_<=(unsigned char)'\342');}
  {int i_=(unsigned char)'\200';do{ (*(i_+rootscope_-((unsigned char)'\200')))=(char)(255) ;i_++;}while(i_<=(unsigned char)'\342');}
topstrand_=('\201');curscope_=(char)(255);TraceOn_=0;



bufstart_=ibuf_;curfile_=0;outfile_=0;inpstack_=0;inputend_=0;zero_='\000';duecento55_='\377';
/*! get = \002*/










































/*!  \060..\064 = 0..4; \070 = 8*/
































  
  
/*! attenzione al tipo di processore*/
/*!  pushaddr=push8*/
/*!  dloadaddr=dload8*/






/*! blue=esc"[34m"*/
/*! magenta=esc"[35m"*/





     
fri_boot21="\353""#" "\356" "\354" "\012" "\370" "\376"		  
  "\352" "USE" "\344" "\356" "\376" "\352" "\347" "\000" "!" "\372" "\376"   
    "\357" "\353"							  
      "\355" "\351" "\356" "\371" "\355" "\005" "\376"                  
      "\355" "\351" "\356" "/usr/local/fri/" "\371" "\355" "\005" "\376"
    "\356" "unable to open " "\371" "\367" "\376"                     
    "\353" "#" "\356" "\354" "\012" "\370" "\376"		  
  "\376"                                                             
  "\353" "\355" "\351" "FRcode" "\373" "\355" "\021" "\376"		  
  "\356" "\200" "FRIsymbol" "\356" "\200" "\363" "\000"                   
  "\356" "\200" "FRIdefinition" "\356" "\201" "\363" "\000"           
  "\356" "\200" "cut" "\356" "\373" "\363" "\000"                            
  "\356" "\200" "trace" "\356" "\355" "\007" "\363" "\000"                  
  "\356" "\200" "openscope" "\356" "\375" "\363" "\000"                
  "\356" "\200" "pushNo" "\356" "\355" "\375" "\363" "\000"             
  "\356" "\200" "closescope" "\356" "\374" "\363" "\000"              
  "\356" "\200" "resetNo" "\356" "\355" "\374" "\363" "\000"           
  "\356" "\200" "convert" "\356" "\343" "\363" "\000"                    
  "\356" "\200" "1[" "\356" "\353" "\363" "\000"                          
  "\356" "\200" "[" "\356" "\352" "\363" "\000"                           
  "\356" "\200" "ifnot[" "\356" "\351" "\363" "\000"                       
  "\356" "\200" "]" "\345" "\345" "\376" "\363" "\000"                       
  "\356" "\200" "try[" "\356" "\355" "\351" "\345" "\376" "\363" "\000"         
  "\356" "\200" "{" "\356" "\022" "\363" "\000"                        
  "\356" "\200" "}" "\356" "\023" "\363" "\000"                       
  "\356" "\200" "*" "\345" "\345" "\354" "\363" "\000"                  
  "\356" "\200" "AssignStrand" "\356" "\355" "\001" "\363" "\000"          
  "\356" "\200" "UniqueNo" "\345" "\345" "\004" "\363" "\000"           
  "\356" "\200" "increment" "\356" "\355" "\016" "\363" "\000"          
  "\356" "\200" "writeimage" "\356" "\355" "\020" "\363" "\000"        
  "\356" "\200" "LineNo" "\345" "\345" "\003" "\363" "\000"               
  "\356" "\200" "delete" "\345" "\345" "\362" "\363" "\000"               
  "\356" "\200" "=[" "\373" "\355" "B" "\345" "\345" "\356" 	  
    "\356" "\200" "=[" "\356" "\356" "\345" "\363" "\000"			  
    "\344" "\352" "\350" "]" "\350" "*" "\350" ":" "\351" "->" "\345" "\376" 
    "\360" "\200" "\344" "\345" "\376" "\356" "\200" "=[" "\356" "\356" "\345" "\376" "\345" "\362" "\370" 
    "\353" "]=" "\355" "C" "\345" "\345" "\177" "\345" "\376" "\345" "\376" "\356" "\363" "\000" 
  "\356" "\200" "<" "\355" "B" "\345" "\345" "\356" 		  
    "\356" "\200" "=[" "\356" "\356" "\345" "\363" "\000"			  
    "\344" "\352" "\350" ">" "\360" "\200" "\344" "\345" "\376" 	  
    "\356" "\200" "=[" "\356" "\356" "\345" "\376" "\345" "\362" "\370" "\345" "\376" "\363" "\000" 
  "\356" "\200" "]=" "\345" "\345" "\177" "\363" "\000"   		  
  "\356" "\200" "^" "\345" "\345" "\345" "\000" "\363" "\000" 		  
  "\356" "\200" "]->error" "\345" "\345" "\367" "\363" "\000"             
  "\356" "\200" "]->out" "\345" "\345" "\366" "\363" "\000"               
  "\356" "\200" "]->back" "\345" "\345" "\365" "\363" "\000"             
  "\356" "\200" "]>" "\355" "C" "\345" "\345" "\364" "\363" "\000" 
  "\356" "\200" "]->" "\355" "C" "\345" "\345" "\363" "\363" "\000"  
  "\356" "\200" "]->" "\355" "C" "0" "\345" "\345" "\363" "\356" "\000" "\345" "\177" "\345" "\376" "\363" "\000" 
  "\356" "\200" "->" "\355" "C" "\345" "\345" "\357" "\363" "\000"   
  "\356" "\200" "do" "\356" "\360" "\363" "\000"                            
  "\356" "\200" "get" "\356" "\355" "\345" "\345" "\002" "\363" "\000"         
  "\356" "\200" "chain" "\356" "\361" "\363" "\000"                        
  "\356" "\200" "*]=" "\345" "\345" "\371" "\363" "\000"                 
  "\356" "\200" "copy" "\356" "\372" "\363" "\000"                          
  "\356" "\200" "backspace" "\355" "C" "\356" "\370" "\363" "\000" 
  "\356" "\200" "-" "\356" "\347" "\363" "\000"                          
  "\356" "\200" "--" "\356" "\350" "\363" "\000"                           
  "\356" "\200" "spaces" "\356" "\344" "\363" "\000"                      
  "\356" "\200" "include" "\356" "\355" "\005" "\363" "\000"              
  "\356" "\200" "younger" "\356" "\355" "\017" "\363" "\000"            
  "\356" "\200" "open" "\356" "\355" "\013" "\363" "\000"              
  "\356" "\200" "close" "\356" "\355" "\014" "\363" "\000"           
  "\356" "\200" "ascii" "\356" "\355" "\006" "\363" "\000"                    
  "\356" "\200" "\"" "\352" "\350" "\"" "\350" "\012" "\372" "\345" "\376" "\373" "\"" "\345" "\376" "\363" "\000" 
  "\356" "\200" "#" "\345" "\345" "\346" "\363" "\000"                    
  "\356" "\200" "#-" "\345" "\345" "\346" "\372" "\355" "E" "\363" "\000" 
  "\356" "\200" "@+" "\355" "B" "\363" "\000"			  
  "\356" "\200" "@-" "\355" "C" "\363" "\000"                    
  "\356" "\200" "@" "\356" "\200" "#" "\345" "\376" "\352" "\350" " " "\350" "\012" "\372" "\345" "\376" "\373" " " 
    "\345" "\345" "\345" "\346" "\345" "\345" "\345" "\000" "\355" "D" "\356" "\355" "E" "\345" "\177" "\345" "\363" "\000" "\345" "\376" "\363" "\000" 
  "\356" "\201" "\345" "\177" "\344" "\012" "\356" "\201" "\363" "\000"
  "\356" "\201" "\345" "\177" "\375" "\355" "A" "\360" "\200" "\344" "\352" "\360" "\200" "\344" "\345" "\376" "\374" "\345" "\363" "\000" "\356" "\201" "\363" "\000" 
  "\376"								  
"\356""\200" "goto" "\345" "\345" "\001" "\345" "\376" "\363" "\000"       
  "\356" "\200" "bcall" "\345" "\345" "\003" "\345" "\376" "\363" "\000"     
  "\356" "\200" "mcall" "\345" "\345" "\004" "\345" "\376" "\363" "\000"     
  "\356" "\200" "push4" "\345" "\345" "\010" "\345" "\376" "\363" "\000"     
  "\356" "\200" "push8" "\345" "\345" "\011" "\345" "\376" "\363" "\000"     
  "\356" "\200" "pushaddr" "\345" "\345" "\010" "\345" "\376" "\363" "\000" 
  "\356" "\200" "saddr" "\345" "\345" "\014" "\345" "\376" "\363" "\000"     
  "\356" "\200" "sload4" "\345" "\345" "\020" "\345" "\376" "\363" "\000"   
  "\356" "\200" "sload8" "\345" "\345" "\021" "\345" "\376" "\363" "\000"   
  "\356" "\200" "sload" "\345" "\345" "\022" "\345" "\376" "\363" "\000"     
  "\356" "\200" "dload4" "\345" "\345" "\023" "\345" "\376" "\363" "\000"   
  "\356" "\200" "dload8" "\345" "\345" "\024" "\345" "\376" "\363" "\000"   
  "\356" "\200" "dloadaddr" "\345" "\345" "\023" "\345" "\376" "\363" "\000" 
  "\356" "\200" "dload" "\345" "\345" "\025" "\345" "\376" "\363" "\000"     
  "\356" "\200" "iload" "\345" "\345" "\026" "\345" "\376" "\363" "\000"     
  "\356" "\200" "ssave4" "\345" "\345" "\030" "\345" "\376" "\363" "\000"   
  "\356" "\200" "ssave8" "\345" "\345" "\031" "\345" "\376" "\363" "\000"   
  "\356" "\200" "ssave" "\345" "\345" "\032" "\345" "\376" "\363" "\000"     
  "\356" "\200" "dsave4" "\345" "\345" "\033" "\345" "\376" "\363" "\000"   
  "\356" "\200" "dsave8" "\345" "\345" "\034" "\345" "\376" "\363" "\000"   
  "\356" "\200" "dsave" "\345" "\345" "\035" "\345" "\376" "\363" "\000"     
  "\356" "\200" "isave" "\345" "\345" "\036" "\345" "\376" "\363" "\000"     
  "\356" "\200" "sframe" "\345" "\345" "\015" "\345" "\376" "\363" "\000"   
  "\356" "\200" "sres" "\345" "\345" "\016" "\345" "\376" "\363" "\000"       
  "\356" "\200" "sdel" "\345" "\345" "\017" "\345" "\376" "\363" "\000"       
  "\356" "\200" "gres" "\345" "\345" "\006" "\345" "\376" "\363" "\000"       
  "\356" "\200" "gdel" "\345" "\345" "\007" "\345" "\376" "\363" "\000"       
  "\356" "\200" "iadd" "\345" "\345" "\040" "\345" "\376" "\363" "\000"       
  "\356" "\200" "isub" "\345" "\345" "\041" "\345" "\376" "\363" "\000"       
  "\356" "\200" "imul" "\345" "\345" "\042" "\345" "\376" "\363" "\000"       
  "\356" "\200" "idiv" "\345" "\345" "\043" "\345" "\376" "\363" "\000"       
  "\356" "\200" "imod" "\345" "\345" "\044" "\345" "\376" "\363" "\000"       
  "\356" "\200" "iand" "\345" "\345" "\045" "\345" "\376" "\363" "\000"       
  "\356" "\200" "ior" "\345" "\345" "\046" "\345" "\376" "\363" "\000"         
  "\356" "\200" "ixor" "\345" "\345" "\047" "\345" "\376" "\363" "\000"       
  "\356" "\200" "irshift" "\345" "\345" "\050" "\345" "\376" "\363" "\000" 
  "\356" "\200" "ilshift" "\345" "\345" "\051" "\345" "\376" "\363" "\000" 
  "\356" "\200" "addradd" "\345" "\345" "\054" "\345" "\376" "\363" "\000" 
  "\356" "\200" "imuladd" "\345" "\345" "\055" "\345" "\376" "\363" "\000" 
  "\356" "\200" "imuladdaddr" "\345" "\345" "\056" "\345" "\376" "\363" "\000" 
  "\356" "\200" "dadd" "\345" "\345" "\120" "\345" "\376" "\363" "\000"       
  "\356" "\200" "dsub" "\345" "\345" "\121" "\345" "\376" "\363" "\000"       
  "\356" "\200" "dmul" "\345" "\345" "\122" "\345" "\376" "\363" "\000"       
  "\356" "\200" "ddiv" "\345" "\345" "\123" "\345" "\376" "\363" "\000"       
  "\356" "\200" "ddisp" "\345" "\345" "\124" "\345" "\376" "\363" "\000"     
  "\356" "\200" "dconv" "\345" "\345" "\125" "\345" "\376" "\363" "\000"     
  "\356" "\200" "idisp" "\345" "\345" "\052" "\345" "\376" "\363" "\000"     
  "\356" "\200" "iconv" "\345" "\345" "\053" "\345" "\376" "\363" "\000"     
  "\356" "\200" "pushstr" "\345" "\345" "\151" "\345" "\376" "\363" "\000" 
  "\356" "\200" "ldisp" "\345" "\345" "\152" "\345" "\376" "\363" "\000"     
  "\356" "\200" "fflush" "\345" "\345" "\153" "\345" "\376" "\363" "\000" 
  "\356" "\200" "inot" "\345" "\345" "\130" "\345" "\376" "\363" "\000"       
  "\356" "\200" "ichs" "\345" "\345" "\131" "\345" "\376" "\363" "\000"       
  "\356" "\200" "ineg" "\345" "\345" "\132" "\345" "\376" "\363" "\000"       
  "\356" "\200" "iabs" "\345" "\345" "\133" "\345" "\376" "\363" "\000"       
  "\356" "\200" "dchs" "\345" "\345" "\134" "\345" "\376" "\363" "\000"       
  "\356" "\200" "dabs" "\345" "\345" "\135" "\345" "\376" "\363" "\000"       
  "\356" "\200" "cb" "\345" "\345" "\136" "\345" "\376" "\363" "\000"		
  "\356" "\200" "ieq" "\345" "\345" "\100" "\345" "\376" "\363" "\000"         
  "\356" "\200" "ine" "\345" "\345" "\101" "\345" "\376" "\363" "\000"         
  "\356" "\200" "igt" "\345" "\345" "\102" "\345" "\376" "\363" "\000"         
  "\356" "\200" "ige" "\345" "\345" "\103" "\345" "\376" "\363" "\000"         
  "\356" "\200" "ilt" "\345" "\345" "\104" "\345" "\376" "\363" "\000"         
  "\356" "\200" "ile" "\345" "\345" "\105" "\345" "\376" "\363" "\000"         
  "\356" "\200" "seq" "\345" "\345" "\110" "\345" "\376" "\363" "\000"         
  "\356" "\200" "sne" "\345" "\345" "\111" "\345" "\376" "\363" "\000"         
  "\356" "\200" "dgt" "\345" "\345" "\112" "\345" "\376" "\363" "\000"         
  "\356" "\200" "dge" "\345" "\345" "\113" "\345" "\376" "\363" "\000"         
  "\356" "\200" "dlt" "\345" "\345" "\114" "\345" "\376" "\363" "\000"         
  "\356" "\200" "dle" "\345" "\345" "\115" "\345" "\376" "\363" "\000"		
  "\356" "\200" "if" "\345" "\345" "\140" "\345" "\376" "\363" "\000"           
  "\356" "\200" "nif" "\345" "\345" "\141" "\345" "\376" "\363" "\000"		
  "\356" "\200" "and" "\345" "\345" "\142" "\345" "\376" "\363" "\000"         
  "\356" "\200" "or" "\345" "\345" "\143" "\345" "\376" "\363" "\000"							
  "\356" "\200" "bytexec[" "\356" "\355" "\352" "\363" "\000"          
  "\356" "\200" "shell command" "\356" "\355" "\025" "\363" "\000"            
  "\356" "\200" "dynamic library" "\355" "B" "\356" "\355" "\026" "\363" "\000"            
  "\356" "\200" "dlclose" "\356" "\355" "\027" "\363" "\000"          
  "\356" "\200" "dl symbol" "\355" "B" "\356" "\355" "\030" "\363" "\000"              
  "\356" "\200" "scanint" "\356" "\355" "\031" "\363" "\000"            
  "\356" "\200" "scanreal" "\356" "\355" "\032" "\363" "\000"          
  "\356" "\200" "=>" "\356" "\355" "\024" "\363" "\000"	        
  "\356" "\200" "length" "\345" "\345" "\034" "\363" "\000"            
  "\356" "\200" "chdir" "\356" "\355" "\035" "\363" "\000"              
  "\356" "\200" "`" "\345" "\345" "\036" "\363" "\000"                  
"\356" "\200" "list->" "\356" "\355" "G" "\363" "\000"            
  "\356" "\200" "wrsym" "\356" "\355" "F" "\363" "\000"             
  "\373" "\356" "\201" "\357" "\177" "\376";
ioptrs_.input_.pos_=0; ioptrs_.input_.iend_=0;
ioptrs_.output_=buffer_;
ioptrs_.parstack_=bufmark_;
 {int i_=argc-1  ;while(i_>=1){ 
  (*(char **)(ioptrs_.parstack_))=ioptrs_.output_;
  {  strcpy(((*(char **)(ioptrs_.parstack_))),((*(char **)(i_*sizeof(char*)+argv))));
};
  {do{ioptrs_.output_  =1+ioptrs_.output_;;}while(!((*(ioptrs_.output_))=='\000'));}
  if( !fri_16Include() ){ sprintf(ERRORMESSAGE_, """FRI:: unable to open \"" "%s\"",(*(char **)(ioptrs_.parstack_) )); longjmp(errorhook,1);};
i_-=1;};}
(*(char **)(ioptrs_.parstack_))=buffer_;
if( fri_bcode_1Match(&NIL_,fri_boot21,100000+fri_boot21) ){ };
if( TraceOn_ ){ fri_9TraceOut();};
}return 0;}
